/*
    
    Config Jerry 6
        Micro Mouse Robot 
            Hamid Davoodi Shandiz
                Islamic Azad University Of Mashad ( IAUM )
    
    
    Date Update 1   :    1390 - 04 - 29     Test & Ok - Sensor - PWM Motor

*/

#ifndef __Config_Jerry_6__
    #define __Config_Jerry_6__
    
// Data For Motor Left
#define FLM 0x02  //Front Left Motor
#define BLM 0x01  //Back Left Motor
#define SLM 0x00  //Stop Left Motor
 
#define FRM 0x20  //Front Right Motor
#define BRM 0x10  //Back Right Motor
#define SRM 0x00  //Stop Right Motor

#define Front_Motor 0x04
#define Back_Motor 0x01

    char MSRM = 4 ; // Max Speed Right Motor
    char MSLM = 4 ; // Max Speed Left Motor

char Counter,Counter_Sensor;
unsigned int Encoder_Right,Encoder_Left;

unsigned int FCS_On,FCS_Off,ValueFCS; // Front Center Sensor
unsigned int FRS_On,FRS_Off,ValueFRS; // Front Right Sensor
unsigned int FLS_On,FLS_Off,ValueFLS; // Front Left Sensor
unsigned int RS_On,RS_Off,ValueRS; // Right Sensor
unsigned int LS_On,LS_Off,ValueLS; // Left Sensor

char Accuracy_Sensor = 1 ,Counter_Accuracy_Sensor;
char Speed_Right_Motor=0,Wheel_Right_Motor = Front_Motor,PWM_Right_Motor;
char Speed_Left_Motor=0,Wheel_Left_Motor = Front_Motor,PWM_Left_Motor;
char PWM_Counter ;

//char PWM_Counter_Left ;
//char PWM_Counter_Right ;
char Acceleration_Motor = 1 ;
//char Acceleration_Motor_Right = 1 ;
//char Acceleration_Motor_Left = 1 ;
char Acceleration_Counter ;
//char Acceleration_Counter_Right = 1 ;
//char Acceleration_Counter_Left = 1 ;
char Value_PORTD;


unsigned int read_adc(unsigned char adc_input);    
   
// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{
    Encoder_Right ++;
}

// External Interrupt 1 service routine
interrupt [EXT_INT1] void ext_int1_isr(void)
{
    Encoder_Left ++;
}

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
        if (PORTC.7==1)PORTC.7=0;
        else PORTC.7=1;
        if ( PWM_Right_Motor > PWM_Counter )
        {
            if ( Wheel_Right_Motor == Front_Motor )
            {            
                PORTD.4 = 0 ;
                PORTD.0 = 1 ;
            }
            else if ( Wheel_Right_Motor == Back_Motor )
            {            
                PORTD.4 = 1 ;
                PORTD.0 = 0 ;
            }
        }
        else if ( PWM_Right_Motor <= PWM_Counter )
        {
            PORTD.4 = 0 ;
            PORTD.0 = 0 ;
        }
        
        if ( PWM_Left_Motor > PWM_Counter )
        {
            if ( Wheel_Left_Motor == Front_Motor )
            {            
                PORTD.5 = 0 ;
                PORTD.7 = 1 ;
            }
            else if ( Wheel_Left_Motor == Back_Motor )
            {            
                PORTD.5 = 1 ;
                PORTD.7 = 0 ;
            }
        }
        else if ( PWM_Left_Motor <= PWM_Counter )
        {
            PORTD.5 = 0 ;
            PORTD.7 = 0 ;
        }  
    
    PWM_Counter++;
    if (PWM_Counter>=20)
    {
        PWM_Counter=0;                                 
        
        Acceleration_Counter ++ ;                  
        if ( Acceleration_Motor <= Acceleration_Counter )
        {
            Acceleration_Counter = 0 ;
            if ( PWM_Right_Motor > Speed_Right_Motor ) PWM_Right_Motor -- ;
            else if ( PWM_Right_Motor < Speed_Right_Motor ) PWM_Right_Motor ++ ;
            
            if ( PWM_Left_Motor > Speed_Left_Motor ) PWM_Left_Motor -- ;
            else if ( PWM_Left_Motor < Speed_Left_Motor ) PWM_Left_Motor ++ ;
        } 
    }  

}
/*
// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
    PWM_Left_Motor = Speed_Left_Motor;
    PWM_Right_Motor = Speed_Right_Motor;
    
        //if (PORTC.7==1)PORTC.7=0;
        //else PORTC.7=1;
        if ( PWM_Right_Motor > PWM_Counter )
        {
            if ( Wheel_Right_Motor == Front_Motor )
            {            
                //PORTD.4 = 1 ;
                //PORTD.0 = 0 ;
                PORTD.4 = 0 ;
                PORTD.0 = 1 ;
            }
            else if ( Wheel_Right_Motor == Back_Motor )
            {            
                //PORTD.4 = 0 ;
                //PORTD.0 = 1 ;
                PORTD.4 = 1 ;
                PORTD.0 = 0 ;
                
            }
        }
        else if ( PWM_Right_Motor <= PWM_Counter )
        {
            PORTD.4 = 0 ;
            PORTD.0 = 0 ;
        }
        
        if ( PWM_Left_Motor > PWM_Counter )
        {
            if ( Wheel_Left_Motor == Front_Motor )
            {            
                //PORTD.5 = 1 ;
                //PORTD.7 = 0 ;
                PORTD.5 = 0 ;
                PORTD.7 = 1 ;
            }
            else if ( Wheel_Left_Motor == Back_Motor )
            {            
                //PORTD.5 = 0 ;
                //PORTD.7 = 1 ;
                PORTD.5 = 1 ;
                PORTD.7 = 0 ;
            }
        }
        else if ( PWM_Left_Motor <= PWM_Counter )
        {
            PORTD.5 = 0 ;
            PORTD.7 = 0 ;
        }  
    

    
    PWM_Counter_Right++;
    if (PWM_Counter_Right>=20)
    {
        PWM_Counter_Right=0;                                 

    }  
 
    PWM_Counter_Left++;
    if (PWM_Counter_Left>=20)
    {
        PWM_Counter_Left=0;                                 

    }  
}
*/

// Timer1 overflow interrupt service routine
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
    TCNT1H=0xd0;
    TCNT1L=0x00; 

//PORTB.3=1;    
/*
    if (Counter_Sensor == 1)
    {
        FRS_Off = 0 ; FRS_On = 0 ;
        FLS_Off = 0 ; FLS_On = 0 ;
        RS_Off = 0 ; RS_On = 0 ;
        LS_Off = 0 ; LS_On = 0 ; 
        PORTC=0x80;   
    }
    else if (Counter_Sensor == 2){FRS_On += read_adc(4);PORTC=0x10;}
    else if (Counter_Sensor == 3){FLS_On += read_adc(7);PORTC=0x40;}
    else if (Counter_Sensor == 4){RS_On += read_adc(5);PORTC=0x20;}
    else if (Counter_Sensor == 5){LS_On += read_adc(6);PORTC=0x00;}
    else if (Counter_Sensor == 6)
    {
        FRS_Off += read_adc(4);
        FLS_Off += read_adc(7); 
        RS_Off += read_adc(5); 
        LS_Off += read_adc(6);      
    }     
    else if (Counter_Sensor == 7)
    {
        if ( Counter_Accuracy_Sensor >= Accuracy_Sensor )
        {
            Counter_Accuracy_Sensor = 1;
            Counter_Sensor = 0 ;
            ValueFRS = (FRS_Off - FRS_On) / Accuracy_Sensor ;
            ValueFLS = (FLS_Off - FLS_On) / Accuracy_Sensor ;
            ValueRS = (RS_Off - RS_On) / Accuracy_Sensor ;
            ValueLS = (LS_Off - LS_On) / Accuracy_Sensor ;
        }
        else
        {
            Counter_Accuracy_Sensor ++ ;
            Counter_Sensor = 1 ;
        }    
    }    
*/
PORTC &= 0xe0; 
switch (Counter_Sensor) {
    case 1 :
        FCS_Off = 0 ; FCS_On = 0 ;
        FRS_Off = 0 ; FRS_On = 0 ;
        FLS_Off = 0 ; FLS_On = 0 ;
        RS_Off = 0 ; RS_On = 0 ;
        LS_Off = 0 ; LS_On = 0 ; 
        PORTC|=0x01;
    break;
    case 2 :
        FLS_On += read_adc(4);PORTC |= 0x02;
    break;   
    case 3 :
        LS_On += read_adc(3);PORTC |= 0x04;
    break;
    case 4 :
        FCS_On += read_adc(2);PORTC |= 0x08;
    break;
    case 5 :
        RS_On += read_adc(1);PORTC |= 0x10;
    break; 
    case 6 :
        FRS_On += read_adc(0);PORTC |=0x00;
    break;
    case 7 :
        FLS_Off += read_adc(4);
        LS_Off  += read_adc(3); 
        FCS_Off += read_adc(2); 
        RS_Off  += read_adc(1);    
        FRS_Off += read_adc(0);
    break;
    case 8 :
        if ( Counter_Accuracy_Sensor >= Accuracy_Sensor )
        {
            Counter_Accuracy_Sensor = 1;
            Counter_Sensor = 0 ;                             
            ValueFCS = (FCS_Off - FCS_On) / Accuracy_Sensor ;
            ValueFRS = (FRS_Off - FRS_On) / Accuracy_Sensor ;
            ValueFLS = (FLS_Off - FLS_On) / Accuracy_Sensor ;
            ValueRS = (RS_Off - RS_On) / Accuracy_Sensor ;
            ValueLS = (LS_Off - LS_On) / Accuracy_Sensor ;
            
        }
        else
        {
            Counter_Accuracy_Sensor ++ ;
            Counter_Sensor = 1 ;
            PORTC=0x01;
        }   
    break;
    };
    
        Counter_Sensor ++ ;        
        
        
        //if (Acceleration_Counter >= 10 ) Acceleration_Counter = 0 ;    
//PORTB.3=0;
}

// Timer2 overflow interrupt service routine
interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
// Place your code here

}

#define ADC_VREF_TYPE 0x40

// Read the AD conversion result
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}

void Code_Main(void)
{
// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0xff;
DDRB=0x00;

// Port C initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTC=0x00;
DDRC=0xFF;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTD=0x0c;
DDRD=0xf3;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 8000.000 kHz
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 8000.000 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;  // For On Timer
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 8000.000 kHz
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x01;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Rising Edge
// INT1: On
// INT1 Mode: Rising Edge
// INT2: Off
GICR|=0xC0;
MCUCR=0x0F;
MCUCSR=0x00;
GIFR=0xC0;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x45;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 1000.000 kHz
// ADC Voltage Reference: AVCC pin
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x83;
// SPI initialization
// SPI disabled
SPCR=0x00;

// TWI initialization
// TWI disabled
TWCR=0x00;
}

#endif
