
#define Run_Setup 0x01
#define PIN_Button1 0x01
#define PORT_Button1 PINB

    #define Attention_Center 3
    #define Attention_Max 1

char ik,jk;
int AMCFSR ;//Avreg Max Center Front Sensor Right
int AMCFSL ;//Avreg Max Center Front Sensor Left
    
eeprom unsigned int Setting_Robot = 0x00 ;
eeprom unsigned int EPR_Center_FCS,EPR_Max_FCS; // Front Center Sensor
eeprom unsigned int EPR_Center_FRS,EPR_Max_FRS; // Front Right Sensor
eeprom unsigned int EPR_Center_FLS,EPR_Max_FLS; // Front Left Sensor
eeprom unsigned int EPR_Center_RS,EPR_Max_RS,EPR_Min_RS; // Right Sensor
eeprom unsigned int EPR_Center_LS,EPR_Max_LS,EPR_Min_LS; // Left Sensor

eeprom unsigned char EPR_Wall_Homes[16][16]=                 //  RPT  0  0  0  N  E  S  W
        {
          {3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,9},     // 1
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 2
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 3
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 4
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 5
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 6
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 7
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 8
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 9
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 10
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 11
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 12
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 13
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 14
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 15
          {6,4,4,4,4,4,4,4,4,4,4,4,4,4,4,12}     // 16
        };    
void Save(void)
    {
        for ( ik = 0 ; ik < 16; ik++ )
        {
            for ( jk = 0 ; jk < 16; jk++ )
                {
                    EPR_Wall_Homes[ik][jk]=Wall_Homes[ik][jk];
                }
        }
    } 
void Load_Save (void)
    {
        for ( ik = 0 ; ik < 16; ik++ )
        {
            for ( jk = 0 ; jk < 16; jk++ )
                {
                    Wall_Homes[ik][jk]=EPR_Wall_Homes[ik][jk];
                }
        }
        Update_Ver3();
    }
void Load_Config(void)
    {
        Center_FCS = EPR_Center_FCS ;
        Max_FCS = EPR_Max_FCS ;

        Center_FRS = EPR_Center_FRS ;
        Max_FRS = EPR_Max_FRS ;

        Center_FLS = EPR_Center_FLS ; 
        Max_FLS = EPR_Max_FLS ;
        
        Center_RS = EPR_Center_RS ;
        Max_RS = EPR_Max_RS ;
        Min_RS = EPR_Min_RS ;
        
        Center_LS = EPR_Center_LS ;
        Max_LS = EPR_Max_LS ;
        Min_LS = EPR_Min_LS ; 
        
        AMCFSR = ( Center_FRS - Max_FRS ) / 2 ;
        AMCFSL = ( Center_FLS - Max_FLS ) / 2 ;
    }
void Setup_Jerr_6 (void)
    {
        Accuracy_Sensor = 5 ;        
        lcd_clear();
        sprintf(buff,"Jerry %d Setup V %d ",VersionJerry , VersionProgram);
        lcd_gotoxy(0,0);lcd_puts(buff);
        
        lcd_gotoxy(0,1);lcd_putsf("Place Center        ");delay_ms(1000);
        while (( PINB & 0x08 ) != 0x00 )
        {   
            lcd_gotoxy(0,2);lcd_putsf("                    ");
            lcd_gotoxy(0,3);lcd_putsf("                    ");
            
            sprintf(buff,"FRS %d ",ValueFRS);
            lcd_gotoxy(0,2);lcd_puts(buff);
            
            sprintf(buff,"FLS %d ",ValueFLS);
            lcd_gotoxy(10,2);lcd_puts(buff);
            
            sprintf(buff,"RS %d ",ValueRS);
            lcd_gotoxy(0,3);lcd_puts(buff);

            sprintf(buff,"LS %d ",ValueLS);
            lcd_gotoxy(10,3);lcd_puts(buff);
            
            delay_ms(50);            
        }                          
        EPR_Center_FRS = ValueFRS ;
        EPR_Center_FLS = ValueFLS ;
        EPR_Center_RS = ValueRS ;
        EPR_Center_LS = ValueLS ;
        lcd_gotoxy(13,1);lcd_putsf("-Save-");
        
        delay_ms(1000);
        
        lcd_gotoxy(0,1);lcd_putsf("Place MaxFrnt       ");
        while (( PINB & 0x08 ) != 0x00 )
        {
            lcd_gotoxy(0,2);lcd_putsf("                    ");
            sprintf(buff,"FRS %d ",ValueFRS);
            lcd_gotoxy(0,2);lcd_puts(buff);
            
            sprintf(buff,"FLS %d ",ValueFLS);
            lcd_gotoxy(10,2);lcd_puts(buff);
            
            delay_ms(50);            
        }                          
        EPR_Max_FRS = ValueFRS ;
        EPR_Max_FLS = ValueFLS ;
        lcd_gotoxy(13,1);lcd_putsf("-Save-");
        delay_ms(1000);
        
        lcd_gotoxy(0,1);lcd_putsf("Place Right         ");
        while (( PINB & 0x08 ) != 0x00 )
        {
            lcd_gotoxy(10,3);lcd_putsf("          ");
            sprintf(buff,"LS %d ",ValueLS);
            lcd_gotoxy(10,3);lcd_puts(buff);
            
            lcd_gotoxy(0,3);lcd_putsf("          ");
            sprintf(buff,"RS %d ",ValueRS);
            lcd_gotoxy(0,3);lcd_puts(buff);
            
            delay_ms(50);            
        }                          
        EPR_Max_LS = ValueLS ;
        EPR_Min_RS = ValueRS ;   
        lcd_gotoxy(13,1);lcd_putsf("-Save-");
        delay_ms(1000); 
        
        lcd_gotoxy(0,1);lcd_putsf("Place Left          ");
        
        while (( PINB & 0x08 ) != 0x00 )
        {
            lcd_gotoxy(10,3);lcd_putsf("          ");
            sprintf(buff,"LS %d ",ValueLS);
            lcd_gotoxy(10,3);lcd_puts(buff);
            
            lcd_gotoxy(0,3);lcd_putsf("          ");
            sprintf(buff,"RS %d ",ValueRS);
            lcd_gotoxy(0,3);lcd_puts(buff);
            
            delay_ms(50);            
        }                          
        EPR_Max_RS = ValueRS ;
        EPR_Min_LS = ValueLS ;
        lcd_clear();
        lcd_gotoxy(0,1);lcd_putsf("----- Save All -----");
        delay_ms(1000);
        lcd_clear();
        Accuracy_Sensor = 1 ;
        Setting_Robot |= Run_Setup ;
    }  
void Setup_Jerr_7 (void)
    {
        Accuracy_Sensor = 5 ;        
        lcd_clear();
        sprintf(buff,"Jerry %d Setup V %d ",VersionJerry , VersionProgram);
        lcd_gotoxy(0,0);lcd_puts(buff);
        lcd_gotoxy(0,2);lcd_puts("----- RunSetup -----");
        delay_ms(1000);
        
        Enable_Sensor();
                
        lcd_clear();
        lcd_gotoxy(0,0);lcd_putsf("Place Center        ");delay_ms(1000);
        while (( PORT_Button1 & PIN_Button1 ) != 0x00 )
        {   
            
            sprintf(buff,"FCS %d ",ValueFCS);
            lcd_gotoxy(7,1);lcd_puts(buff);

            sprintf(buff,"FRS %d ",ValueFRS);
            lcd_gotoxy(0,2);lcd_puts(buff);
            
            sprintf(buff,"FLS %d ",ValueFLS);
            lcd_gotoxy(10,2);lcd_puts(buff);
            
            delay_ms(50);            
        }                          
        EPR_Center_FCS = ValueFCS ;
        EPR_Center_FRS = ValueFRS ;
        EPR_Center_FLS = ValueFLS ;

        lcd_gotoxy(13,1);lcd_putsf("-Save-");
        delay_ms(1000);
        
        lcd_clear();
        lcd_gotoxy(0,0);lcd_putsf("Place MaxFrnt       ");
        while (( PORT_Button1 & PIN_Button1 ) != 0x00 )
        {
            sprintf(buff,"FCS %d ",ValueFCS);
            lcd_gotoxy(7,1);lcd_puts(buff);
            
            sprintf(buff,"FRS %d ",ValueFRS);
            lcd_gotoxy(0,2);lcd_puts(buff);
            
            sprintf(buff,"FLS %d ",ValueFLS);
            lcd_gotoxy(10,2);lcd_puts(buff);
            
            sprintf(buff,"RS %d ",ValueRS);
            lcd_gotoxy(0,3);lcd_puts(buff);

            sprintf(buff,"LS %d ",ValueLS);
            lcd_gotoxy(10,3);lcd_puts(buff);
            
            
            delay_ms(50);            
        }                          
        EPR_Max_FCS = ValueFCS ;
        EPR_Max_FRS = ValueFRS ;
        EPR_Max_FLS = ValueFLS ;
        EPR_Center_RS = ValueRS + Attention_Center ;
        EPR_Center_LS = ValueLS + Attention_Center ;
        lcd_gotoxy(13,1);lcd_putsf("-Save-");
        delay_ms(1000);
        
        lcd_clear();
        lcd_gotoxy(0,0);lcd_putsf("Place Right         ");
        while (( PORT_Button1 & PIN_Button1 ) != 0x00 )
        {
            sprintf(buff,"LS %d ",ValueLS);
            lcd_gotoxy(10,3);lcd_puts(buff);
            
            sprintf(buff,"RS %d ",ValueRS);
            lcd_gotoxy(0,3);lcd_puts(buff);
            
            delay_ms(50);            
        }                          
        EPR_Max_LS = ValueLS - Attention_Max ;
        EPR_Min_RS = ValueRS ;   
        lcd_gotoxy(13,1);lcd_putsf("-Save-");
        delay_ms(1000); 
        
        lcd_clear();
        lcd_gotoxy(0,0);lcd_putsf("Place Left          ");
        while (( PORT_Button1 & PIN_Button1 ) != 0x00 )
        {
            sprintf(buff,"LS %d ",ValueLS);
            lcd_gotoxy(10,3);lcd_puts(buff);
            
            sprintf(buff,"RS %d ",ValueRS);
            lcd_gotoxy(0,3);lcd_puts(buff);
            
            delay_ms(50);            
        }                          
        EPR_Max_RS = ValueRS - Attention_Max ;
        EPR_Min_LS = ValueLS ;
        lcd_clear();
        lcd_gotoxy(0,1);lcd_putsf("----- Save All -----");
        delay_ms(1000);
        lcd_clear();
        Accuracy_Sensor = 1 ;
        Setting_Robot |= Run_Setup ;    
        
        Disable_Sensor();
    }