

#ifndef LCD_WR
		#define  LCD_WR    PORTB.5
#endif

#ifndef LCD_RD    
		#define  LCD_RD    PORTB.4
#endif

#ifndef LCD_CE
		#define  LCD_CE    PORTB.3
#endif

#ifndef LCD_CD
		#define  LCD_CD    PORTB.2
#endif

#ifndef LCD_RST
		#define  LCD_RST   PORTB.1
#endif

#ifndef LCD_FS1
		#define  LCD_FS1   PORTB.0 
#endif

#ifndef DDR_Control_Port 
		#define  DDR_Control_Port DDRB
#endif

#ifndef PIN_Control_Port 
		#define  PIN_Control_Port PINB
#endif

#ifndef PORT_Control_Port 
		#define  PORT_Control_Port PORTB 
#endif

#ifndef DDR_Data_Port 
		#define  DDR_Data_Port DDRD 
#endif

#ifndef PIN_Data_Port 
		#define  PIN_Data_Port PIND
#endif

#ifndef PORT_Data_Port 
		#define  PORT_Data_Port PORTD
#endif



#define EightbyEight          0  // fonts

#define Busy1Busy2         0x03  // Status masks 
#define DAWRDY             0x08

#define CursorPointerSet      0x21
#define OffsetRegisterSet     0x22
#define AddressPointerSet     0x24
#define TextHomeAddress     0x40
#define TextAreaSet         0x41
#define GraphicHomeAddress     0x042
#define GraphicAreaSet      0x043
#define CGROMMode          0x80
#define CGRAMMode          0x88
#define ORMode             0x80
#define EXORMode           0x81
#define ANDMode           0x83
#define Textonly           0x84
#define GraphicsOff          0x90
#define GraphicsOn           0x98
#define TextOff              0x90
#define TextOn               0x94
#define CursorOff            0x90
#define CursorOn             0x92
#define CursorBlinkOff      0x90
#define CursorBlinkOn         0x91
#define CursorPattern          0xA0
#define BottomLine            0x0
#define DataAutoWrite          0xB0
#define DataAutoRead           0xB1
#define AutoReset              0xB2
#define DataRdWr          0xC0
#define BitReset            0xF0
#define BitSet              0xF8

#define GraphBase          0x0000       // base address of graphics memory
#define TextBase          0x1000       // base address of text memory
                              
#ifndef Column       
		#define Column       240    
#endif

#ifndef Row
		#define Row          128             
#endif

char FontSize ;
unsigned int charsPerRow ;

void lcd_Graphic_init();
void WriteText(char String[] ,int x1,int y1);
void StatBusy12(void);
void StatDAWRDY(void);
void DataOut(char b);
void CommandOut(char b);
void lcd_clear_graphic();
void lcd_clear_text();
void lcd_Graphic(flash char Graphic_Picture[]);
void lcd_Graphic_Variable(eeprom char Graphic_Picture[]);
void lcd_print(char *string);
void lcd_pixel(int X, int Y, char SetReset);
void lcd_xy(int X, int Y);
void SetAutoMode();
void AutoOut(char b);
void ResetAutoMode();
void lcd_cursorXY(char X, char Y);
void DataOut2(int data);
void AutoZero(unsigned int Terminate);
void lcd_setup_page(int Pages);
void lcd_line(char line);


//-----------------------------------------
void WriteText(char String[] ,int x1,int y1)
{  
  //lcd_setup_page(3);
  //lcd_clear_text();                                                   
  CommandOut(GraphicsOn| TextOn | CursorOff | CursorBlinkOn);
  lcd_xy(x1,y1); 
  lcd_print(String);       
}  
//-------------------------------------------
void lcd_Graphic(flash char Graphic_Picture[])
{                 
    int i;   
    lcd_clear_graphic();                          
   CommandOut(GraphicsOn | TextOff | CursorOff);
   lcd_clear_graphic();  
   DataOut(0);
   CommandOut(AddressPointerSet); 
   SetAutoMode();
   for(i=0;i<(Row*Column)/8 ;i++)
      AutoOut(Graphic_Picture[i]);
   ResetAutoMode();         
}
//-------------------------------------------
void lcd_Graphic_Variable(eeprom char Graphic_Picture[])
{                 
    int i;   
    lcd_clear_graphic();                          
   CommandOut(GraphicsOn | TextOff | CursorOff);
   lcd_clear_graphic();  
   DataOut(0);
   CommandOut(AddressPointerSet); 
   SetAutoMode();
   for(i=0;i<(Row*Column)/8 ;i++)
      AutoOut(Graphic_Picture[i]);
   ResetAutoMode();         
}       
//-----------------------------------------
void lcd_line(char line)
{
   char i;
   CommandOut(GraphicsOn | TextOn | CursorOff);   
   for(i=0;i<Column;i++)
      lcd_pixel(i,line,1);
}
//-----------------------------------------
void lcd_Graphic_init()
{
   //PORTB = 0x1F;        // FS low all else high
LCD_WR=1;    //PORTB.5
LCD_RD=1;    //PORTB.4
LCD_CE=1;    //PORTB.3
LCD_CD=1;    //PORTB.2
LCD_RST=1;   //PORTB.1
LCD_FS1=0;   //PORTB.0 

   //DDRB = 0xff;            // output portb
DDR_Control_Port =0xff;
   PORT_Data_Port = 0;
   DDR_Data_Port = 0xff;            // output porta   
   LCD_CE = 1;              // All control lines HI
   LCD_RD = 1;
   LCD_WR = 1;
   LCD_CD = 1;
   LCD_RST = 0;            // Reset LCD
   delay_us(1);                     // Delay 1 ms for reset could be shorter
   LCD_RST = 1;            // Release Reset
   delay_us(1);                     // unnecessary 
   LCD_FS1 = EightbyEight ;        // Set font 8x8 
   if ( LCD_FS1 == EightbyEight)     // Set Font Size 
    {
      FontSize = 8 ; 
      charsPerRow = Column / FontSize ;
     }         
   else
    {
      FontSize = 6 ;
      charsPerRow = Column / FontSize ;  
    }   
   CommandOut(GraphicsOff | TextOff  | CursorOff );   
   DataOut2(GraphBase);          // Graphic Base Address   
   CommandOut(GraphicHomeAddress);    
   DataOut2(charsPerRow);        // Graphic Area    
   CommandOut(GraphicAreaSet);    
   DataOut2(TextBase);            // Text Base Address      
   CommandOut(TextHomeAddress); 
   DataOut2(charsPerRow);                 // Text Area     
   CommandOut(TextAreaSet);  
   CommandOut(EXORMode | CGROMMode); // mode set  
   CommandOut(CursorPattern | 7);      // cursor is 8 lines high   
   lcd_clear_graphic();
   lcd_clear_text(); 
   lcd_cursorXY(0,0);                // Move Cursor to (x,y)
}
//--------------------------------
void lcd_clear_graphic()
{
     DataOut2(GraphBase);
     CommandOut(AddressPointerSet); 
     AutoZero( charsPerRow * Row  );
}

//----------------------------------
void lcd_clear_text()
{
   DataOut2(TextBase);
   CommandOut(AddressPointerSet);
   AutoZero( charsPerRow * ( Row /8 ));
}
//---------------------------------
void lcd_print(char *string)
{
   char *p; 
   p= string ;   
   SetAutoMode();
   while (*p)
      AutoOut(*p++ - 0x20);
   ResetAutoMode();
}
//------------------------------------
void lcd_pixel(int X, int Y, char SetReset)
{
   char Bit; 
   Bit= (FontSize-1) - (X % FontSize); 
   DataOut2(GraphBase + (Y * charsPerRow) + (X / FontSize));
   CommandOut(AddressPointerSet);
   if ( SetReset )
     CommandOut(BitSet   | Bit);
   else
     CommandOut(BitReset | Bit );   
}
//------------------------------------
void lcd_xy(int X, int Y)
{
   DataOut2(TextBase + (Y * charsPerRow) + X);
   CommandOut(AddressPointerSet);
}
//-----------------------------------
void lcd_setup_page(int Pages)
{
   charsPerRow = 16 * Pages;     
   DataOut2(TextBase);			
   CommandOut(TextHomeAddress); 
   DataOut2(charsPerRow);		
   CommandOut(TextAreaSet); 
}           
//-----------------------------------
void lcd_cursorXY(char X, char Y)
{
   DataOut(X);
   DataOut(Y);
   CommandOut(CursorPointerSet); 
}
//--------------------------------------
void AutoZero( unsigned int Terminate)
{
  SetAutoMode();
  while(Terminate--)
    AutoOut(0);
  ResetAutoMode() ;
}    
                                      
//-------------------------------------
void StatBusy12()
{
   char lcd_status;
   DDR_Data_Port = 0x00;  // Input porta 
   do
   {  
      LCD_CE = 0;
      LCD_RD = 0;
      delay_us(1);
      lcd_status = PIN_Data_Port; 
      LCD_CE = 1;
      LCD_RD = 1;
   }
   while ((lcd_status & Busy1Busy2) != Busy1Busy2);    
   DDR_Data_Port = 0xff; // output porta 

}
//-------------------------------
void StatDAWRDY()
{
   char lcd_status;
   DDR_Data_Port = 0x00;   
   do
   {
      LCD_CE = 0;
      LCD_RD = 0;    
      delay_us(1);
      lcd_status = PIN_Data_Port; 
      LCD_CE = 1;
      LCD_RD = 1;
   }
   while ((lcd_status & DAWRDY) != DAWRDY);    
   DDR_Data_Port = 0xff;  

}
//------------------------------
void DataOut(char b)
{
   StatBusy12();
   LCD_CD = 0;
   PORT_Data_Port = b;
   LCD_CE = 0; 
   LCD_WR = 0;
   LCD_CE = 1;
   LCD_WR = 1;
   LCD_CD = 1;
}
//------------------------------
void DataOut2(int data)
{
    DataOut(data & 0xFF);
    DataOut(data >> 8);
}    
//------------------------------
void CommandOut(char b)
{    	
   StatBusy12();
   PORT_Data_Port = b;
   LCD_CE = 0;
   LCD_WR = 0; 
   LCD_CE = 1;
   LCD_WR = 1;
}
//-------------------------------
void SetAutoMode()
{
  CommandOut(DataAutoWrite);
}
//--------------------------------

void AutoOut(char b)
{
   StatDAWRDY();
   LCD_CD = 0;   
   PORT_Data_Port = b;
   LCD_CE = 0; 
   LCD_WR = 0;
   LCD_CE = 1;
   LCD_WR = 1;
   LCD_CD = 1;
}                                 
//---------------------------------
void ResetAutoMode()
{
   StatDAWRDY();
   PORT_Data_Port = AutoReset;
   LCD_CE = 0;
   LCD_WR = 0; 
   LCD_CE = 1;
   LCD_WR = 1;
}

