/*
Program         :    Algorithm Maze Robot
Version         :    5.154
Programer       :    Hamid Davoodi Shandiz
                        www.HDavoodi.com  
                        Hamid.Davoodi.Sh@Gmail.com

Compiler        :    Win AVR - Avr GCC - AVR Studio 5 - AVR Studio 4 - CodeVision AVR - MicroC Pro AVR
						Visual C++ And Orther Language C & C++
Comment         :

*/
/*
 90 & 45 & Arc

 NW     N     NE
    \   |   /
     \  |  /
      \ | /
W ------|------ E
      / | \
     /  |  \
    /   |   \
 SW     S     SE                     

=====>  Star Main Program  <=====

        Index_Robot.X =0;
        Index_Robot.Y =0;

        Finish_Home_1.X =7;
        Finish_Home_1.Y =7;
        Finish_Home_2.X =8;
        Finish_Home_2.Y =7;
        Finish_Home_3.X =7;
        Finish_Home_3.Y =8;
        Finish_Home_4.X =8;
        Finish_Home_4.Y =8;

        while (1)
            {
                Go();
            }
*/
#ifndef __Maze_Alguritm__
    #define __Maze_Alguritm__
//#ifndef LED_Update
//        #define LED_Update PORTE.0   // For Mega 128
//#endif
#define N 0x08                       // North
#define NE 0x0c                      // North & East
#define E 0x04                       // East
#define SE1 0x06                     // South & East
#define S 0x02                       // South
#define SW 0x03                      // South & West
#define W 0x01                       // West
#define NW 0x09                      // North & West
#define RPT 0x80                     // Repeat

#define RS 0x01                      // Right Sensor
#define FS 0x02                      // Front Sensor
#define LS 0x03                      // Left Sensor

#define Move_45 1                    // Type Move 45
#define Move_90 0                    // Type Move 90

#define On_ALG 1
#define Off_ALG 0

#define Point_Center 0x0F
#define Point_Up     0x01
#define Point_Down   0x02
#define Point_Right  0x04
#define Point_Left   0x08

        struct X_Y
        {
            char X;
            char Y;
        };
        struct X_Y Index_Robot;  //  X , Y  Robot
//        struct X_Y Index_Robot_RPT;  //  X , Y  Robot For Repeat (RPT)
        struct X_Y Finish_Home_1;
        struct X_Y Finish_Home_2;
        struct X_Y Finish_Home_3;
        struct X_Y Finish_Home_4;
    unsigned char Angle_Robot = N;
    unsigned char Angle_Move_Robot_First;
    unsigned char Angle_Move_Robot_Second;
    unsigned char Back_Way = 0;
    unsigned char Len_Way = 0;
    unsigned char Len_Way_A = 0;
    unsigned char Small_Len_Way = Off_ALG;
    unsigned char Check_Home_Finish = Off_ALG;
    unsigned char Sens_Sensor;
    unsigned char Type_Move = 0;   //        ј
    unsigned char Model_Move = Off_ALG;    
    unsigned char Index_Robot_Point = Point_Center;
    // Update
        unsigned char IndexA = 0;     //  
        unsigned char Switch = 0;
        unsigned char And ;
        unsigned char And_x ;
    // =======
    //char Move_Darage;
    unsigned int i,j,k,l;
unsigned char Homes[16][16]=
        {
        //   1 ,2 ,3 ,4 ,5 ,6 ,7 ,8 ,9 ,10,11,12,13,14,15,16
        //------------------------------------------------------
        {14,13,12,11,10, 9, 8, 7, 7, 8, 9,10,11,12,13,14},  // 1
        {13,12,11,10, 9, 8, 7, 6, 6, 7, 8, 9,10,11,12,13},  // 2
        {12,11,10, 9, 8, 7, 6, 5, 5, 6, 7, 8, 9,10,11,12},  // 3
        {11,10, 9, 8, 7, 6, 5, 4, 4, 5, 6, 7, 8, 9,10,11},  // 4
        {10, 9, 8, 7, 6, 5, 4, 3, 3, 4, 5, 6, 7, 8, 9,10},  // 5
        { 9, 8, 7, 6, 5, 4, 3, 2, 2, 3, 4, 5, 6, 7, 8, 9},  // 6
        { 8, 7, 6, 5, 4, 3, 2, 1, 1, 2, 3, 4, 5, 6, 7, 8},  // 7
        { 7, 6, 5, 4, 3, 2, 1, 0, 0, 1, 2, 3, 4, 5, 6, 7},  // 8
        { 7, 6, 5, 4, 3, 2, 1, 0, 0, 1, 2, 3, 4, 5, 6, 7},  // 9
        { 8, 7, 6, 5, 4, 3, 2, 1, 1, 2, 3, 4, 5, 6, 7, 8},  // 10
        { 9, 8, 7, 6, 5, 4, 3, 2, 2, 3, 4, 5, 6, 7, 8, 9},  // 11
        {10, 9, 8, 7, 6, 5, 4, 3, 3, 4, 5, 6, 7, 8, 9,10},  // 12
        {11,10, 9, 8, 7, 6, 5, 4, 4, 5, 6, 7, 8, 9,10,11},  // 13
        {12,11,10, 9, 8, 7, 6, 5, 5, 6, 7, 8, 9,10,11,12},  // 14
        {13,12,11,10, 9, 8, 7, 6, 6, 7, 8, 9,10,11,12,13},  // 15
        {14,13,12,11,10, 9, 8, 7, 7, 8, 9,10,11,12,13,14}   // 16

        };
#ifndef ___Wall_Homes_Maze___
unsigned char Wall_Homes[16][16]=                 //  RPT  ChAR  ChAR1  ChAR2  N  E  S  W
        {
          {3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,9},     // 1
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 2
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 3
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 4
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 5
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 6
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 7
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 8
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 9
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 10
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 11
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 12
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 13
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 14
          {2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 15
          {6,4,4,4,4,4,4,4,4,4,4,4,4,4,4,12}     // 16
        };
#endif

/*
unsigned char Wall_Homes[16][16]=                 //  RPT  0  0  0  N  E  S  W
        {
          {3,5,5,5,5,5,5,5,5,5,5,5,5,5,5,9},     // 1
          {10,2,7,7,7,7,7,7,7,7,7,7,7,7,3,12},     // 2
          {10,2,6,9,0,0,0,0,0,0,0,0,0,3,12,8},     // 3
          {10,2,0,6,9,0,0,0,0,0,0,0,3,12,0,8},     // 4
          {10,2,0,0,6,9,0,0,0,0,0,3,12,0,0,8},     // 5
          {10,2,0,0,0,6,9,0,0,0,3,12,0,0,0,8},     // 6
          {10,2,0,0,0,0,6,9,0,3,12,0,0,0,0,8},     // 7
          
          {10,2,0,0,0,0,0,  3,9,  0,0,0,0,0,0,8},     // 8
          {10,2,0,0,0,0,0,  2,12, 0,0,0,0,0,0,8},     // 9
          
          {10,2,0,0,0,0,3,12,0,0,0,0,0,0,0,8},     // 10
          {10,2,0,0,0,3,12,0,0,0,0,0,0,0,0,8},     // 11
          {10,2,0,0,3,12,0,0,0,0,0,0,0,0,0,8},     // 12
          {10,2,0,3,12,0,0,0,0,0,0,0,0,0,0,8},     // 13
          {10,6,3,12,0,0,0,0,0,0,0,0,0,0,0,8},     // 14
          {10,3,12,0,0,0,0,0,0,0,0,0,0,0,0,8},     // 15
          {6,12,4,4,4,4,4,4,4,4,4,4,4,4,4,12}     // 16
        };
*/
void Save(void);
void Lock(char AMotor);

void Front_Half_Size_Home();//{}
void Right_45();//{}
// 45 Right
void Left_45();//{}
// 45 Left
void Front();//{}
void Front_45();//{}// For Move 45
// Front 1 Home
// Eslah
void Back();//{}
// 180
void Right();//{}
// 90 Right
void Left();//{}
// 90 Left
void Right_Arc();//{}
// Arc 90 Right
void Left_Arc();//{}
// Arc 90 Left
unsigned int Read_Sensor(unsigned char Namber_Sensor_Wall);//{}
// First Wall ==> return 1
// Second Wall ==> return 2
// Non Wall ==> return 0
void Check_Wall()
    {
        // Check Walls   ====================================================================
        // Read_Sensor(RS)    Right Sensor ROBOT
        // Read_Sensor(Fs)    Front Sensor ROBOT
        // Read_Sensor(Ls)    Left  Sensor ROBOT
        if ( Angle_Robot == N )
        {
            Sens_Sensor = Read_Sensor(RS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= E ;             // Right Sensor Wall One
                if ( Index_Robot.X < 15 ) Wall_Homes[ Index_Robot.X + 1 ] [ Index_Robot.Y ] |= W ;
            }
            Sens_Sensor = Read_Sensor(FS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= N ;             // Front Sensor Wall One
                if ( Index_Robot.Y < 15 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y + 1 ] |= S ;
            }
            Sens_Sensor = Read_Sensor(LS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= W ;             // Back Sensor Wall One
                if ( Index_Robot.X > 0 ) Wall_Homes[ Index_Robot.X - 1 ] [ Index_Robot.Y ] |= E ;
            }
        }
// --------------------------------------------------------------------------
        else if ( Angle_Robot == E )
        {
            Sens_Sensor = Read_Sensor(RS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= S ;             // Right Sensor Wall One
                if ( Index_Robot.Y > 0 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y - 1 ] |= N ;
            }
            Sens_Sensor = Read_Sensor(FS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= E ;             // Right Sensor Wall One
                if ( Index_Robot.X < 15 ) Wall_Homes[ Index_Robot.X + 1 ] [ Index_Robot.Y ] |= W ;
            }
            Sens_Sensor = Read_Sensor(LS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= N ;             // Front Sensor Wall One
                if ( Index_Robot.Y < 15 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y + 1 ] |= S ;
            }
        }
// --------------------------------------------------------------------------

        else if ( Angle_Robot == S )
        {
            Sens_Sensor = Read_Sensor(RS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= W ;             // Back Sensor Wall One
                if ( Index_Robot.X > 0 ) Wall_Homes[ Index_Robot.X - 1 ] [ Index_Robot.Y ] |= E ;
            }
            Sens_Sensor = Read_Sensor(FS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= S ;             // Right Sensor Wall One
                if ( Index_Robot.Y > 0 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y - 1 ] |= N ;
            }
            Sens_Sensor = Read_Sensor(LS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= E ;             // Right Sensor Wall One
                if ( Index_Robot.X < 15 ) Wall_Homes[ Index_Robot.X + 1 ] [ Index_Robot.Y ] |= W ;
            }
        }
         // --------------------------------------------------------------------------
        else if ( Angle_Robot == W )
        {
            Sens_Sensor = Read_Sensor(RS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= N ;             // Back Sensor Wall One
                if ( Index_Robot.Y < 15 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y + 1 ] |= S ;
            }
            Sens_Sensor = Read_Sensor(FS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= W ;             // Right Sensor Wall One
                if ( Index_Robot.X > 0 ) Wall_Homes[ Index_Robot.X - 1 ] [ Index_Robot.Y ] |= E ;
            }
            Sens_Sensor = Read_Sensor(LS);
            if (Sens_Sensor == 1)
            {
                Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y ] |= S ;             // Right Sensor Wall One
                if ( Index_Robot.Y > 0 ) Wall_Homes[ Index_Robot.X ] [ Index_Robot.Y - 1 ] |= N ;
            }
        }
        // End Check Walls   ================================================================
    }
void Darage(char DRG)
    {
        if (DRG == N )
            {
                if (Angle_Robot==E)Left();
                else if (Angle_Robot==W)Right();
                else if (Angle_Robot==S)Back();

                else if (Angle_Robot==NW)Right_45();
                else if (Angle_Robot==NE)Left_45();
                else if (Angle_Robot==SW){Right();Right_45();}
                else if (Angle_Robot==SE1){Left();Left_45();}
                Angle_Robot=N;
            }
        else if (DRG == E )
            {
                if (Angle_Robot==S)Left();
                else if (Angle_Robot==N)Right();
                else if (Angle_Robot==W)Back();

                else if (Angle_Robot==NE)Right_45();
                else if (Angle_Robot==SE1)Left_45();
                else if (Angle_Robot==NW){Right();Right_45();}
                else if (Angle_Robot==SW){Left();Left_45();}
                Angle_Robot=E;
            }
        else if (DRG == S )
            {
                if (Angle_Robot==W)Left();
                else if (Angle_Robot==E)Right();
                else if (Angle_Robot==N)Back();

                else if (Angle_Robot==SE1)Right_45();
                else if (Angle_Robot==SW)Left_45();
                else if (Angle_Robot==NE){Right();Right_45();}
                else if (Angle_Robot==NW){Left();Left_45();}
                Angle_Robot=S;
            }
        else if (DRG == W )
            {
                if (Angle_Robot==N)Left();
                else if (Angle_Robot==S)Right();
                else if (Angle_Robot==E)Back();

                else if (Angle_Robot==SW)Right_45();
                else if (Angle_Robot==NW)Left_45();
                else if (Angle_Robot==SE1){Right();Right_45();}
                else if (Angle_Robot==NE){Left();Left_45();}
                Angle_Robot=W;
            }
        else if (DRG == NE )
            {
                if (Angle_Robot==SE1)Left();
                else if (Angle_Robot==NW)Right();
                else if (Angle_Robot==SW)Back();

                else if (Angle_Robot==N)Right_45();
                else if (Angle_Robot==E)Left_45();
                else if (Angle_Robot==W){Right();Right_45();}
                else if (Angle_Robot==S){Left();Left_45();}
                Angle_Robot=NE;
            }
        else if (DRG == NW )
            {
                if (Angle_Robot==NE)Left();
                else if (Angle_Robot==SW)Right();
                else if (Angle_Robot==SE1)Back();

                else if (Angle_Robot==W)Right_45();
                else if (Angle_Robot==N)Left_45();
                else if (Angle_Robot==S){Right();Right_45();}
                else if (Angle_Robot==E){Left();Left_45();}
                Angle_Robot=NW;
            }
        else if (DRG == SW )
            {
                if (Angle_Robot==NW)Left();
                else if (Angle_Robot==SE1)Right();
                else if (Angle_Robot==NE)Back();

                else if (Angle_Robot==S)Right_45();
                else if (Angle_Robot==W)Left_45();
                else if (Angle_Robot==E){Right();Right_45();}
                else if (Angle_Robot==N){Left();Left_45();}
                Angle_Robot=SW;
            }
        else if (DRG == SE1 )
            {
                if (Angle_Robot==SW)Left();
                else if (Angle_Robot==NE)Right();
                else if (Angle_Robot==NW)Back();

                else if (Angle_Robot==E)Right_45();
                else if (Angle_Robot==S)Left_45();
                else if (Angle_Robot==N){Right();Right_45();}
                else if (Angle_Robot==W){Left();Left_45();}
                Angle_Robot=SE1;
            }
    }
void Darage_Arc(char DRG)
    {
        if (DRG == N )
            {
                if (Angle_Robot==E)Left_Arc();
                else if (Angle_Robot==W)Right_Arc();
                else if (Angle_Robot==S)Back();
                Angle_Robot=N;
            }
        else if (DRG == E )
            {
                if (Angle_Robot==S)Left_Arc();
                else if (Angle_Robot==N)Right_Arc();
                else if (Angle_Robot==W)Back();
                Angle_Robot=E;
            }
        else if (DRG == S )
            {
                if (Angle_Robot==W)Left_Arc();
                else if (Angle_Robot==E)Right_Arc();
                else if (Angle_Robot==N)Back();
                Angle_Robot=S;
            }
        else if (DRG == W )
            {
                if (Angle_Robot==N)Left_Arc();
                else if (Angle_Robot==S)Right_Arc();
                else if (Angle_Robot==E)Back();
                Angle_Robot=W;
            }
    }
void Update()
    {
        Lock(0);
//        LED_Update = 1;

        for (i=0; i<16;i++)
            for (j=0; j<16;j++)
                Homes[i][j]=0xff;

            Homes[Finish_Home_1.X][Finish_Home_1.Y]=0x00;
            Homes[Finish_Home_2.X][Finish_Home_2.Y]=0x00;
            Homes[Finish_Home_3.X][Finish_Home_3.Y]=0x00;
            Homes[Finish_Home_4.X][Finish_Home_4.Y]=0x00;

        for(IndexA=0x00;IndexA<=0xfb;IndexA++)
        {
            for(i=0;i<16;i++)
                for(j=0;j<16;j++)
                    if(Homes[i][j]==IndexA)
                    {
                        And_x = N & Wall_Homes[i][j] ;
                        if ( And_x == 0x00 )
                            if( Homes[i][j+1]==0xff )
                            {
                            Homes[i][j+1]=IndexA+1;
                            Switch=1;
                            }

                        And_x = E & Wall_Homes[i][j] ;
                        if ( And_x == 0x00 )
                            if( Homes[i+1][j]==0xff )
                            {
                            Homes[i+1][j]=IndexA+1;
                            Switch=1;
                            }

                        And_x = W & Wall_Homes[i][j] ;
                        if ( And_x == 0x00 )
                            if( Homes[i-1][j]==0xff )
                            {
                            Homes[i-1][j]=IndexA+1;
                            Switch=1;
                            }

                        And_x = S & Wall_Homes[i][j] ;
                        if ( And_x == 0x00 )
                            if( Homes[i][j-1]==0xff )
                            {
                            Homes[i][j-1]=IndexA+1;
                            Switch=1;
                            }
                    }
            if (Switch == 0) 
				IndexA = 0xfb ;
            else Switch = 0;
        }
//        LED_Update = 0 ;
    }
char Move_Robot()
    {
        Wall_Homes[Index_Robot.X][Index_Robot.Y] |= RPT;   //          
            if (( N & Wall_Homes[Index_Robot.X][Index_Robot.Y]) == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y + 1])
                {
                    Index_Robot.Y = Index_Robot.Y + 1;
                    Darage(N);
                    return 0;
                }

            if(( E & Wall_Homes[Index_Robot.X][Index_Robot.Y] )  == 0x00)
                if (Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X + 1 ][Index_Robot.Y])
                {
                    Index_Robot.X = Index_Robot.X + 1;
                    Darage(E);
                    return 0;
                }
            if(( W & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X - 1 ][Index_Robot.Y])
                {
                    Index_Robot.X = Index_Robot.X - 1;
                    Darage(W);
                    return 0;
                }
            if(( S & Wall_Homes[Index_Robot.X][Index_Robot.Y] ) == 0x00)
                if ( Homes[Index_Robot.X][Index_Robot.Y] > Homes[Index_Robot.X][Index_Robot.Y - 1])
                {
                    Index_Robot.Y = Index_Robot.Y - 1;
                    Darage(S);
                    return 0;
                }
            return 1;


    } 
void Go_To_Center_Point(void)
{
    if ( Index_Robot_Point == Point_Up ) Darage(S);
    else if ( Index_Robot_Point == Point_Down ) Darage(N);
    else if ( Index_Robot_Point == Point_Right ) Darage(W);
    else if ( Index_Robot_Point == Point_Left ) Darage(E);

    Front_Half_Size_Home();
    Index_Robot_Point = Point_Center ;     
}
void Finish()
    {
        if (Index_Robot.X == Finish_Home_1.X || Index_Robot.X == Finish_Home_2.X ||Index_Robot.X == Finish_Home_3.X || Index_Robot.X == Finish_Home_4.X)
        if (Index_Robot.Y == Finish_Home_1.Y || Index_Robot.Y == Finish_Home_2.Y ||Index_Robot.Y == Finish_Home_3.Y || Index_Robot.Y == Finish_Home_4.Y)
        {
            if (Model_Move == On_ALG) Go_To_Center_Point();
            Save ();
            
            if (Check_Home_Finish == On_ALG) 
                if (Back_Way == 5) 
                    Back_Way = 0;
                else 
                    Back_Way = 5;                                                                                                 
            else 
            {
                Back_Way ++ ;
                if (Index_Robot.X == 7 && Index_Robot.Y == 7)Back_Way = 2 ;
            }


            if (Len_Way_A != Len_Way)
            {
                Len_Way_A = Len_Way ;
                Small_Len_Way = Off_ALG;
            }
            else Small_Len_Way = On_ALG;
    
            Len_Way = 0;     
        
            if (Back_Way == 6) 
            {
                    
                Back_Way = 0;
            }
    
            if (Back_Way == 0)
            {
                Finish_Home_1.X =7;Finish_Home_1.Y =7;
                Finish_Home_2.X =8;Finish_Home_2.Y =7;
                Finish_Home_3.X =7;Finish_Home_3.Y =8;
                Finish_Home_4.X =8;Finish_Home_4.Y =8;
            }
            else if (Back_Way == 1 )
            {
                Finish_Home_1.X =7;Finish_Home_1.Y =7;
                Finish_Home_2.X =7;Finish_Home_2.Y =7;
                Finish_Home_3.X =7;Finish_Home_3.Y =7;
                Finish_Home_4.X =7;Finish_Home_4.Y =7;
            }
            else if (Back_Way == 2 )
            {
                Finish_Home_1.X =7;Finish_Home_1.Y =8;
                Finish_Home_2.X =7;Finish_Home_2.Y =8;
                Finish_Home_3.X =7;Finish_Home_3.Y =8;
                Finish_Home_4.X =7;Finish_Home_4.Y =8;
            }
            else if (Back_Way == 3 )
            {
                Finish_Home_1.X =8;Finish_Home_1.Y =8;
                Finish_Home_2.X =8;Finish_Home_2.Y =8;
                Finish_Home_3.X =8;Finish_Home_3.Y =8;
                Finish_Home_4.X =8;Finish_Home_4.Y =8;
            }
            else if (Back_Way == 4 )
            {
                Finish_Home_1.X =8;Finish_Home_1.Y =7;
                Finish_Home_2.X =8;Finish_Home_2.Y =7;
                Finish_Home_3.X =8;Finish_Home_3.Y =7;
                Finish_Home_4.X =8;Finish_Home_4.Y =7;
            }
            else if (Back_Way == 5 )
            {
                Finish_Home_1.X =0;Finish_Home_1.Y =0;
                Finish_Home_2.X =0;Finish_Home_2.Y =0;
                Finish_Home_3.X =0;Finish_Home_3.Y =0;
                Finish_Home_4.X =0;Finish_Home_4.Y =0;
                Check_Home_Finish = On_ALG; 
            }     
            Update();

        }
        
    }

void Go()
    {
                Check_Wall();
                while ( Move_Robot() == 1 )
                {
                    Update();
                }
                Front();
                    Len_Way ++;
                Finish();
    }
#endif
