
;CodeVisionAVR C Compiler V2.05.0 Advanced
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega32
;Program type             : Application
;Clock frequency          : 8.000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 512 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega32
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2143
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x085F
	.EQU __DSTACK_SIZE=0x0200
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _MSRM=R5
	.DEF _MSLM=R4
	.DEF _Counter=R7
	.DEF _Counter_Sensor=R6
	.DEF _Encoder_Right=R8
	.DEF _Encoder_Left=R10
	.DEF _FCS_On=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  _ext_int0_isr
	JMP  _ext_int1_isr
	JMP  0x00
	JMP  0x00
	JMP  _timer2_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer1_ovf_isr
	JMP  0x00
	JMP  _timer0_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

_0x3:
	.DB  0x1
_0x4:
	.DB  0x4
_0x5:
	.DB  0x4
_0x6:
	.DB  0x1
_0x49:
	.DB  0x8
_0x4A:
	.DB  0xF
_0x4B:
	.DB  0xE,0xD,0xC,0xB,0xA,0x9,0x8,0x7
	.DB  0x7,0x8,0x9,0xA,0xB,0xC,0xD,0xE
	.DB  0xD,0xC,0xB,0xA,0x9,0x8,0x7,0x6
	.DB  0x6,0x7,0x8,0x9,0xA,0xB,0xC,0xD
	.DB  0xC,0xB,0xA,0x9,0x8,0x7,0x6,0x5
	.DB  0x5,0x6,0x7,0x8,0x9,0xA,0xB,0xC
	.DB  0xB,0xA,0x9,0x8,0x7,0x6,0x5,0x4
	.DB  0x4,0x5,0x6,0x7,0x8,0x9,0xA,0xB
	.DB  0xA,0x9,0x8,0x7,0x6,0x5,0x4,0x3
	.DB  0x3,0x4,0x5,0x6,0x7,0x8,0x9,0xA
	.DB  0x9,0x8,0x7,0x6,0x5,0x4,0x3,0x2
	.DB  0x2,0x3,0x4,0x5,0x6,0x7,0x8,0x9
	.DB  0x8,0x7,0x6,0x5,0x4,0x3,0x2,0x1
	.DB  0x1,0x2,0x3,0x4,0x5,0x6,0x7,0x8
	.DB  0x7,0x6,0x5,0x4,0x3,0x2,0x1,0x0
	.DB  0x0,0x1,0x2,0x3,0x4,0x5,0x6,0x7
	.DB  0x7,0x6,0x5,0x4,0x3,0x2,0x1,0x0
	.DB  0x0,0x1,0x2,0x3,0x4,0x5,0x6,0x7
	.DB  0x8,0x7,0x6,0x5,0x4,0x3,0x2,0x1
	.DB  0x1,0x2,0x3,0x4,0x5,0x6,0x7,0x8
	.DB  0x9,0x8,0x7,0x6,0x5,0x4,0x3,0x2
	.DB  0x2,0x3,0x4,0x5,0x6,0x7,0x8,0x9
	.DB  0xA,0x9,0x8,0x7,0x6,0x5,0x4,0x3
	.DB  0x3,0x4,0x5,0x6,0x7,0x8,0x9,0xA
	.DB  0xB,0xA,0x9,0x8,0x7,0x6,0x5,0x4
	.DB  0x4,0x5,0x6,0x7,0x8,0x9,0xA,0xB
	.DB  0xC,0xB,0xA,0x9,0x8,0x7,0x6,0x5
	.DB  0x5,0x6,0x7,0x8,0x9,0xA,0xB,0xC
	.DB  0xD,0xC,0xB,0xA,0x9,0x8,0x7,0x6
	.DB  0x6,0x7,0x8,0x9,0xA,0xB,0xC,0xD
	.DB  0xE,0xD,0xC,0xB,0xA,0x9,0x8,0x7
	.DB  0x7,0x8,0x9,0xA,0xB,0xC,0xD,0xE
_0x4C:
	.DB  0x3,0x1,0x1,0x1,0x1,0x1,0x1,0x1
	.DB  0x1,0x1,0x1,0x1,0x1,0x1,0x1,0x9
	.DB  0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8
	.DB  0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8
	.DB  0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8
	.DB  0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8
	.DB  0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8
	.DB  0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8
	.DB  0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8
	.DB  0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8
	.DB  0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8
	.DB  0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8
	.DB  0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8
	.DB  0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8
	.DB  0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8
	.DB  0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8
	.DB  0x6,0x4,0x4,0x4,0x4,0x4,0x4,0x4
	.DB  0x4,0x4,0x4,0x4,0x4,0x4,0x4,0xC
_0x509:
	.DB  0x4,0x4
_0x0:
	.DB  0x4A,0x65,0x72,0x72,0x79,0x20,0x25,0x64
	.DB  0x20,0x53,0x65,0x74,0x75,0x70,0x20,0x56
	.DB  0x20,0x25,0x64,0x20,0x0,0x50,0x6C,0x61
	.DB  0x63,0x65,0x20,0x43,0x65,0x6E,0x74,0x65
	.DB  0x72,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x0,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x0,0x46
	.DB  0x52,0x53,0x20,0x25,0x64,0x20,0x0,0x46
	.DB  0x4C,0x53,0x20,0x25,0x64,0x20,0x0,0x2D
	.DB  0x53,0x61,0x76,0x65,0x2D,0x0,0x50,0x6C
	.DB  0x61,0x63,0x65,0x20,0x4D,0x61,0x78,0x46
	.DB  0x72,0x6E,0x74,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x0,0x50,0x6C,0x61,0x63,0x65
	.DB  0x20,0x52,0x69,0x67,0x68,0x74,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x0
	.DB  0x50,0x6C,0x61,0x63,0x65,0x20,0x4C,0x65
	.DB  0x66,0x74,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x0,0x2D,0x2D,0x2D
	.DB  0x2D,0x2D,0x20,0x53,0x61,0x76,0x65,0x20
	.DB  0x41,0x6C,0x6C,0x20,0x2D,0x2D,0x2D,0x2D
	.DB  0x2D,0x0,0x2D,0x2D,0x2D,0x2D,0x2D,0x20
	.DB  0x52,0x75,0x6E,0x53,0x65,0x74,0x75,0x70
	.DB  0x20,0x2D,0x2D,0x2D,0x2D,0x2D,0x0,0x46
	.DB  0x43,0x53,0x20,0x25,0x64,0x20,0x0,0x3D
	.DB  0x3D,0x20,0x20,0x20,0x20,0x20,0x4A,0x65
	.DB  0x72,0x72,0x79,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x3D,0x3D,0x0,0x3D,0x3D,0x20,0x20
	.DB  0x56,0x65,0x72,0x73,0x69,0x6F,0x6E,0x20
	.DB  0x25,0x64,0x20,0x25,0x64,0x20,0x20,0x3D
	.DB  0x3D,0x0,0x20,0x20,0x20,0x45,0x6C,0x6D
	.DB  0x69,0x72,0x61,0x20,0x4D,0x6F,0x75,0x73
	.DB  0x61,0x76,0x69,0x20,0x20,0x20,0x0,0x20
	.DB  0x20,0x20,0x20,0x48,0x6F,0x64,0x61,0x20
	.DB  0x52,0x61,0x7A,0x6D,0x41,0x72,0x61,0x20
	.DB  0x20,0x20,0x20,0x0,0x53,0x74,0x61,0x72
	.DB  0x74,0x0
_0x2020003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  _Accuracy_Sensor
	.DW  _0x3*2

	.DW  0x01
	.DW  _Wheel_Right_Motor
	.DW  _0x4*2

	.DW  0x01
	.DW  _Wheel_Left_Motor
	.DW  _0x5*2

	.DW  0x01
	.DW  _Acceleration_Motor
	.DW  _0x6*2

	.DW  0x01
	.DW  _Angle_Robot
	.DW  _0x49*2

	.DW  0x01
	.DW  _Index_Robot_Point
	.DW  _0x4A*2

	.DW  0x100
	.DW  _Homes
	.DW  _0x4B*2

	.DW  0x100
	.DW  _Wall_Homes
	.DW  _0x4C*2

	.DW  0x15
	.DW  _0x4CE
	.DW  _0x0*2+170

	.DW  0x02
	.DW  0x04
	.DW  _0x509*2

	.DW  0x02
	.DW  __base_y_G101
	.DW  _0x2020003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x260

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.05.0 Advanced
;Automatic Program Generator
; Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 2/20/2007
;Author  : Hamid Davoodi Shandiz
;Company : IAUM
;Comments:
;            1390/5/4
;
;
;Chip type               : ATmega32
;Program type            : Application
;AVR Core Clock frequency: 8.000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 512
;*****************************************************/
;#include <mega32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <stdio.h>
;#include <alcd.h>
;char buff[20];
;#define VersionJerry  7
;#define VersionProgram  55
;#include <..\Jerry_6\Config_Jerry_6.h>

	.DSEG

	.CSEG
_ext_int0_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	MOVW R30,R8
	ADIW R30,1
	MOVW R8,R30
	RJMP _0x508
_ext_int1_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	MOVW R30,R10
	ADIW R30,1
	MOVW R10,R30
_0x508:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
_timer0_ovf_isr:
	ST   -Y,R26
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
	SBIS 0x15,7
	RJMP _0x7
	CBI  0x15,7
	RJMP _0xA
_0x7:
	SBI  0x15,7
_0xA:
	LDS  R30,_PWM_Counter
	LDS  R26,_PWM_Right_Motor
	CP   R30,R26
	BRSH _0xD
	LDS  R26,_Wheel_Right_Motor
	CPI  R26,LOW(0x4)
	BRNE _0xE
	CBI  0x12,4
	SBI  0x12,0
	RJMP _0x13
_0xE:
	LDS  R26,_Wheel_Right_Motor
	CPI  R26,LOW(0x1)
	BRNE _0x14
	SBI  0x12,4
	CBI  0x12,0
_0x14:
_0x13:
	RJMP _0x19
_0xD:
	LDS  R30,_PWM_Counter
	LDS  R26,_PWM_Right_Motor
	CP   R30,R26
	BRLO _0x1A
	CBI  0x12,4
	CBI  0x12,0
_0x1A:
_0x19:
	LDS  R30,_PWM_Counter
	LDS  R26,_PWM_Left_Motor
	CP   R30,R26
	BRSH _0x1F
	LDS  R26,_Wheel_Left_Motor
	CPI  R26,LOW(0x4)
	BRNE _0x20
	CBI  0x12,5
	SBI  0x12,7
	RJMP _0x25
_0x20:
	LDS  R26,_Wheel_Left_Motor
	CPI  R26,LOW(0x1)
	BRNE _0x26
	SBI  0x12,5
	CBI  0x12,7
_0x26:
_0x25:
	RJMP _0x2B
_0x1F:
	LDS  R30,_PWM_Counter
	LDS  R26,_PWM_Left_Motor
	CP   R30,R26
	BRLO _0x2C
	CBI  0x12,5
	CBI  0x12,7
_0x2C:
_0x2B:
	LDS  R30,_PWM_Counter
	SUBI R30,-LOW(1)
	STS  _PWM_Counter,R30
	LDS  R26,_PWM_Counter
	CPI  R26,LOW(0x14)
	BRLO _0x31
	LDI  R30,LOW(0)
	STS  _PWM_Counter,R30
	LDS  R30,_Acceleration_Counter
	SUBI R30,-LOW(1)
	STS  _Acceleration_Counter,R30
	LDS  R26,_Acceleration_Motor
	CP   R30,R26
	BRLO _0x32
	LDI  R30,LOW(0)
	STS  _Acceleration_Counter,R30
	LDS  R30,_Speed_Right_Motor
	LDS  R26,_PWM_Right_Motor
	CP   R30,R26
	BRSH _0x33
	LDS  R30,_PWM_Right_Motor
	SUBI R30,LOW(1)
	RJMP _0x4E0
_0x33:
	LDS  R30,_Speed_Right_Motor
	LDS  R26,_PWM_Right_Motor
	CP   R26,R30
	BRSH _0x35
	LDS  R30,_PWM_Right_Motor
	SUBI R30,-LOW(1)
_0x4E0:
	STS  _PWM_Right_Motor,R30
_0x35:
	LDS  R30,_Speed_Left_Motor
	LDS  R26,_PWM_Left_Motor
	CP   R30,R26
	BRSH _0x36
	LDS  R30,_PWM_Left_Motor
	SUBI R30,LOW(1)
	RJMP _0x4E1
_0x36:
	LDS  R30,_Speed_Left_Motor
	LDS  R26,_PWM_Left_Motor
	CP   R26,R30
	BRSH _0x38
	LDS  R30,_PWM_Left_Motor
	SUBI R30,-LOW(1)
_0x4E1:
	STS  _PWM_Left_Motor,R30
_0x38:
_0x32:
_0x31:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	LD   R26,Y+
	RETI
_timer1_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	LDI  R30,LOW(208)
	OUT  0x2D,R30
	LDI  R30,LOW(0)
	OUT  0x2C,R30
	IN   R30,0x15
	ANDI R30,LOW(0xE0)
	OUT  0x15,R30
	MOV  R30,R6
	LDI  R31,0
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x3C
	LDI  R30,LOW(0)
	STS  _FCS_Off,R30
	STS  _FCS_Off+1,R30
	CLR  R12
	CLR  R13
	STS  _FRS_Off,R30
	STS  _FRS_Off+1,R30
	STS  _FRS_On,R30
	STS  _FRS_On+1,R30
	STS  _FLS_Off,R30
	STS  _FLS_Off+1,R30
	STS  _FLS_On,R30
	STS  _FLS_On+1,R30
	STS  _RS_Off,R30
	STS  _RS_Off+1,R30
	STS  _RS_On,R30
	STS  _RS_On+1,R30
	STS  _LS_Off,R30
	STS  _LS_Off+1,R30
	STS  _LS_On,R30
	STS  _LS_On+1,R30
	SBI  0x15,0
	RJMP _0x3B
_0x3C:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x3D
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL _read_adc
	LDS  R26,_FLS_On
	LDS  R27,_FLS_On+1
	ADD  R30,R26
	ADC  R31,R27
	STS  _FLS_On,R30
	STS  _FLS_On+1,R31
	SBI  0x15,1
	RJMP _0x3B
_0x3D:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x3E
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _read_adc
	LDS  R26,_LS_On
	LDS  R27,_LS_On+1
	ADD  R30,R26
	ADC  R31,R27
	STS  _LS_On,R30
	STS  _LS_On+1,R31
	SBI  0x15,2
	RJMP _0x3B
_0x3E:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x3F
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _read_adc
	__ADDWRR 12,13,30,31
	SBI  0x15,3
	RJMP _0x3B
_0x3F:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x40
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _read_adc
	LDS  R26,_RS_On
	LDS  R27,_RS_On+1
	ADD  R30,R26
	ADC  R31,R27
	STS  _RS_On,R30
	STS  _RS_On+1,R31
	SBI  0x15,4
	RJMP _0x3B
_0x40:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x41
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _read_adc
	LDS  R26,_FRS_On
	LDS  R27,_FRS_On+1
	ADD  R30,R26
	ADC  R31,R27
	STS  _FRS_On,R30
	STS  _FRS_On+1,R31
	IN   R30,0x15
	RJMP _0x4E2
_0x41:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x42
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL _read_adc
	LDS  R26,_FLS_Off
	LDS  R27,_FLS_Off+1
	ADD  R30,R26
	ADC  R31,R27
	STS  _FLS_Off,R30
	STS  _FLS_Off+1,R31
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _read_adc
	LDS  R26,_LS_Off
	LDS  R27,_LS_Off+1
	ADD  R30,R26
	ADC  R31,R27
	STS  _LS_Off,R30
	STS  _LS_Off+1,R31
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _read_adc
	LDS  R26,_FCS_Off
	LDS  R27,_FCS_Off+1
	ADD  R30,R26
	ADC  R31,R27
	STS  _FCS_Off,R30
	STS  _FCS_Off+1,R31
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _read_adc
	LDS  R26,_RS_Off
	LDS  R27,_RS_Off+1
	ADD  R30,R26
	ADC  R31,R27
	STS  _RS_Off,R30
	STS  _RS_Off+1,R31
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _read_adc
	LDS  R26,_FRS_Off
	LDS  R27,_FRS_Off+1
	ADD  R30,R26
	ADC  R31,R27
	STS  _FRS_Off,R30
	STS  _FRS_Off+1,R31
	RJMP _0x3B
_0x42:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x3B
	LDS  R30,_Accuracy_Sensor
	LDS  R26,_Counter_Accuracy_Sensor
	CP   R26,R30
	BRSH PC+3
	JMP _0x44
	LDI  R30,LOW(1)
	STS  _Counter_Accuracy_Sensor,R30
	CLR  R6
	LDS  R26,_FCS_Off
	LDS  R27,_FCS_Off+1
	SUB  R26,R12
	SBC  R27,R13
	CALL SUBOPT_0x0
	STS  _ValueFCS,R30
	STS  _ValueFCS+1,R31
	LDS  R26,_FRS_On
	LDS  R27,_FRS_On+1
	LDS  R30,_FRS_Off
	LDS  R31,_FRS_Off+1
	CALL SUBOPT_0x1
	STS  _ValueFRS,R30
	STS  _ValueFRS+1,R31
	LDS  R26,_FLS_On
	LDS  R27,_FLS_On+1
	LDS  R30,_FLS_Off
	LDS  R31,_FLS_Off+1
	CALL SUBOPT_0x1
	STS  _ValueFLS,R30
	STS  _ValueFLS+1,R31
	LDS  R26,_RS_On
	LDS  R27,_RS_On+1
	LDS  R30,_RS_Off
	LDS  R31,_RS_Off+1
	CALL SUBOPT_0x1
	STS  _ValueRS,R30
	STS  _ValueRS+1,R31
	LDS  R26,_LS_On
	LDS  R27,_LS_On+1
	LDS  R30,_LS_Off
	LDS  R31,_LS_Off+1
	CALL SUBOPT_0x1
	STS  _ValueLS,R30
	STS  _ValueLS+1,R31
	RJMP _0x45
_0x44:
	LDS  R30,_Counter_Accuracy_Sensor
	SUBI R30,-LOW(1)
	STS  _Counter_Accuracy_Sensor,R30
	LDI  R30,LOW(1)
	MOV  R6,R30
_0x4E2:
	OUT  0x15,R30
_0x45:
_0x3B:
	INC  R6
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
_timer2_ovf_isr:
	RETI
_read_adc:
;	adc_input -> Y+0
	LD   R30,Y
	ORI  R30,0x40
	OUT  0x7,R30
	__DELAY_USB 27
	SBI  0x6,6
_0x46:
	SBIS 0x6,4
	RJMP _0x46
	SBI  0x6,4
	IN   R30,0x4
	IN   R31,0x4+1
	RJMP _0x2080007
_Code_Main:
	LDI  R30,LOW(0)
	OUT  0x1B,R30
	OUT  0x1A,R30
	LDI  R30,LOW(255)
	OUT  0x18,R30
	LDI  R30,LOW(0)
	OUT  0x17,R30
	OUT  0x15,R30
	LDI  R30,LOW(255)
	OUT  0x14,R30
	LDI  R30,LOW(12)
	OUT  0x12,R30
	LDI  R30,LOW(243)
	OUT  0x11,R30
	LDI  R30,LOW(0)
	OUT  0x33,R30
	OUT  0x32,R30
	OUT  0x3C,R30
	OUT  0x2F,R30
	OUT  0x2E,R30
	OUT  0x2D,R30
	OUT  0x2C,R30
	OUT  0x27,R30
	OUT  0x26,R30
	OUT  0x2B,R30
	OUT  0x2A,R30
	OUT  0x29,R30
	OUT  0x28,R30
	OUT  0x22,R30
	LDI  R30,LOW(1)
	OUT  0x25,R30
	LDI  R30,LOW(0)
	OUT  0x24,R30
	OUT  0x23,R30
	IN   R30,0x3B
	ORI  R30,LOW(0xC0)
	OUT  0x3B,R30
	LDI  R30,LOW(15)
	OUT  0x35,R30
	LDI  R30,LOW(0)
	OUT  0x34,R30
	LDI  R30,LOW(192)
	OUT  0x3A,R30
	LDI  R30,LOW(69)
	OUT  0x39,R30
	LDI  R30,LOW(128)
	OUT  0x8,R30
	LDI  R30,LOW(0)
	OUT  0x30,R30
	LDI  R30,LOW(64)
	OUT  0x7,R30
	LDI  R30,LOW(131)
	OUT  0x6,R30
	LDI  R30,LOW(0)
	OUT  0xD,R30
	OUT  0x36,R30
	RET
;#include <..\Maze_Alguritm\Maze.h>

	.DSEG

	.CSEG
_Check_Wall:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x8)
	BRNE _0x4D
	CALL SUBOPT_0x2
	BRNE _0x4E
	CALL SUBOPT_0x3
	CALL SUBOPT_0x4
	CALL SUBOPT_0x5
	BRSH _0x4F
	CALL SUBOPT_0x3
	ADIW R30,1
	CALL SUBOPT_0x4
	ORI  R30,1
	ST   X,R30
_0x4F:
_0x4E:
	CALL SUBOPT_0x6
	BRNE _0x50
	CALL SUBOPT_0x3
	CALL SUBOPT_0x4
	CALL SUBOPT_0x7
	BRSH _0x51
	CALL SUBOPT_0x3
	CALL SUBOPT_0x8
	CALL SUBOPT_0x9
_0x51:
_0x50:
	CALL SUBOPT_0xA
	BRNE _0x52
	CALL SUBOPT_0x3
	CALL SUBOPT_0x4
	CALL SUBOPT_0xB
	BRLO _0x53
	CALL SUBOPT_0x3
	SBIW R30,1
	CALL SUBOPT_0x4
	ORI  R30,4
	ST   X,R30
_0x53:
_0x52:
	RJMP _0x54
_0x4D:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x4)
	BRNE _0x55
	CALL SUBOPT_0x2
	BRNE _0x56
	CALL SUBOPT_0x3
	CALL SUBOPT_0x4
	CALL SUBOPT_0xC
	BRLO _0x57
	CALL SUBOPT_0x3
	CALL SUBOPT_0x8
	CALL SUBOPT_0xD
_0x57:
_0x56:
	CALL SUBOPT_0x6
	BRNE _0x58
	CALL SUBOPT_0x3
	CALL SUBOPT_0x4
	CALL SUBOPT_0x5
	BRSH _0x59
	CALL SUBOPT_0x3
	ADIW R30,1
	CALL SUBOPT_0x4
	ORI  R30,1
	ST   X,R30
_0x59:
_0x58:
	CALL SUBOPT_0xA
	BRNE _0x5A
	CALL SUBOPT_0x3
	CALL SUBOPT_0x4
	CALL SUBOPT_0x7
	BRSH _0x5B
	CALL SUBOPT_0x3
	CALL SUBOPT_0x8
	CALL SUBOPT_0x9
_0x5B:
_0x5A:
	RJMP _0x5C
_0x55:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x2)
	BRNE _0x5D
	CALL SUBOPT_0x2
	BRNE _0x5E
	CALL SUBOPT_0x3
	CALL SUBOPT_0x4
	CALL SUBOPT_0xB
	BRLO _0x5F
	CALL SUBOPT_0x3
	SBIW R30,1
	CALL SUBOPT_0x4
	ORI  R30,4
	ST   X,R30
_0x5F:
_0x5E:
	CALL SUBOPT_0x6
	BRNE _0x60
	CALL SUBOPT_0x3
	CALL SUBOPT_0x4
	CALL SUBOPT_0xC
	BRLO _0x61
	CALL SUBOPT_0x3
	CALL SUBOPT_0x8
	CALL SUBOPT_0xD
_0x61:
_0x60:
	CALL SUBOPT_0xA
	BRNE _0x62
	CALL SUBOPT_0x3
	CALL SUBOPT_0x4
	CALL SUBOPT_0x5
	BRSH _0x63
	CALL SUBOPT_0x3
	ADIW R30,1
	CALL SUBOPT_0x4
	ORI  R30,1
	ST   X,R30
_0x63:
_0x62:
	RJMP _0x64
_0x5D:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x1)
	BRNE _0x65
	CALL SUBOPT_0x2
	BRNE _0x66
	CALL SUBOPT_0x3
	CALL SUBOPT_0x4
	CALL SUBOPT_0x7
	BRSH _0x67
	CALL SUBOPT_0x3
	CALL SUBOPT_0x8
	CALL SUBOPT_0x9
_0x67:
_0x66:
	CALL SUBOPT_0x6
	BRNE _0x68
	CALL SUBOPT_0x3
	CALL SUBOPT_0x4
	CALL SUBOPT_0xB
	BRLO _0x69
	CALL SUBOPT_0x3
	SBIW R30,1
	CALL SUBOPT_0x4
	ORI  R30,4
	ST   X,R30
_0x69:
_0x68:
	CALL SUBOPT_0xA
	BRNE _0x6A
	CALL SUBOPT_0x3
	CALL SUBOPT_0x4
	CALL SUBOPT_0xC
	BRLO _0x6B
	CALL SUBOPT_0x3
	CALL SUBOPT_0x8
	CALL SUBOPT_0xD
_0x6B:
_0x6A:
_0x65:
_0x64:
_0x5C:
_0x54:
	RET
_Darage:
;	DRG -> Y+0
	LD   R26,Y
	CPI  R26,LOW(0x8)
	BRNE _0x6C
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x4)
	BRNE _0x6D
	RCALL _Left
	RJMP _0x6E
_0x6D:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x1)
	BRNE _0x6F
	RCALL _Right
	RJMP _0x70
_0x6F:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x2)
	BRNE _0x71
	RCALL _Back
	RJMP _0x72
_0x71:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x9)
	BRNE _0x73
	RCALL _Right_45
	RJMP _0x74
_0x73:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0xC)
	BREQ _0x4E3
	CPI  R26,LOW(0x3)
	BRNE _0x77
	CALL SUBOPT_0xE
	RJMP _0x78
_0x77:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x6)
	BRNE _0x79
	RCALL _Left
_0x4E3:
	RCALL _Left_45
_0x79:
_0x78:
_0x74:
_0x72:
_0x70:
_0x6E:
	LDI  R30,LOW(8)
	RJMP _0x4E4
_0x6C:
	LD   R26,Y
	CPI  R26,LOW(0x4)
	BRNE _0x7B
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x2)
	BRNE _0x7C
	RCALL _Left
	RJMP _0x7D
_0x7C:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x8)
	BRNE _0x7E
	RCALL _Right
	RJMP _0x7F
_0x7E:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x1)
	BRNE _0x80
	RCALL _Back
	RJMP _0x81
_0x80:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0xC)
	BRNE _0x82
	RCALL _Right_45
	RJMP _0x83
_0x82:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x6)
	BREQ _0x4E5
	CPI  R26,LOW(0x9)
	BRNE _0x86
	CALL SUBOPT_0xE
	RJMP _0x87
_0x86:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x3)
	BRNE _0x88
	RCALL _Left
_0x4E5:
	RCALL _Left_45
_0x88:
_0x87:
_0x83:
_0x81:
_0x7F:
_0x7D:
	LDI  R30,LOW(4)
	RJMP _0x4E4
_0x7B:
	LD   R26,Y
	CPI  R26,LOW(0x2)
	BRNE _0x8A
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x1)
	BRNE _0x8B
	RCALL _Left
	RJMP _0x8C
_0x8B:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x4)
	BRNE _0x8D
	RCALL _Right
	RJMP _0x8E
_0x8D:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x8)
	BRNE _0x8F
	RCALL _Back
	RJMP _0x90
_0x8F:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x6)
	BRNE _0x91
	RCALL _Right_45
	RJMP _0x92
_0x91:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x3)
	BREQ _0x4E6
	CPI  R26,LOW(0xC)
	BRNE _0x95
	CALL SUBOPT_0xE
	RJMP _0x96
_0x95:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x9)
	BRNE _0x97
	RCALL _Left
_0x4E6:
	RCALL _Left_45
_0x97:
_0x96:
_0x92:
_0x90:
_0x8E:
_0x8C:
	LDI  R30,LOW(2)
	RJMP _0x4E4
_0x8A:
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0x99
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x8)
	BRNE _0x9A
	RCALL _Left
	RJMP _0x9B
_0x9A:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x2)
	BRNE _0x9C
	RCALL _Right
	RJMP _0x9D
_0x9C:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x4)
	BRNE _0x9E
	RCALL _Back
	RJMP _0x9F
_0x9E:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x3)
	BRNE _0xA0
	RCALL _Right_45
	RJMP _0xA1
_0xA0:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x9)
	BREQ _0x4E7
	CPI  R26,LOW(0x6)
	BRNE _0xA4
	CALL SUBOPT_0xE
	RJMP _0xA5
_0xA4:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0xC)
	BRNE _0xA6
	RCALL _Left
_0x4E7:
	RCALL _Left_45
_0xA6:
_0xA5:
_0xA1:
_0x9F:
_0x9D:
_0x9B:
	LDI  R30,LOW(1)
	RJMP _0x4E4
_0x99:
	LD   R26,Y
	CPI  R26,LOW(0xC)
	BRNE _0xA8
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x6)
	BRNE _0xA9
	RCALL _Left
	RJMP _0xAA
_0xA9:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x9)
	BRNE _0xAB
	RCALL _Right
	RJMP _0xAC
_0xAB:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x3)
	BRNE _0xAD
	RCALL _Back
	RJMP _0xAE
_0xAD:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x8)
	BRNE _0xAF
	RCALL _Right_45
	RJMP _0xB0
_0xAF:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x4)
	BREQ _0x4E8
	CPI  R26,LOW(0x1)
	BRNE _0xB3
	CALL SUBOPT_0xE
	RJMP _0xB4
_0xB3:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x2)
	BRNE _0xB5
	RCALL _Left
_0x4E8:
	RCALL _Left_45
_0xB5:
_0xB4:
_0xB0:
_0xAE:
_0xAC:
_0xAA:
	LDI  R30,LOW(12)
	RJMP _0x4E4
_0xA8:
	LD   R26,Y
	CPI  R26,LOW(0x9)
	BRNE _0xB7
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0xC)
	BRNE _0xB8
	RCALL _Left
	RJMP _0xB9
_0xB8:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x3)
	BRNE _0xBA
	RCALL _Right
	RJMP _0xBB
_0xBA:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x6)
	BRNE _0xBC
	RCALL _Back
	RJMP _0xBD
_0xBC:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x1)
	BRNE _0xBE
	RCALL _Right_45
	RJMP _0xBF
_0xBE:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x8)
	BREQ _0x4E9
	CPI  R26,LOW(0x2)
	BRNE _0xC2
	CALL SUBOPT_0xE
	RJMP _0xC3
_0xC2:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x4)
	BRNE _0xC4
	RCALL _Left
_0x4E9:
	RCALL _Left_45
_0xC4:
_0xC3:
_0xBF:
_0xBD:
_0xBB:
_0xB9:
	LDI  R30,LOW(9)
	RJMP _0x4E4
_0xB7:
	LD   R26,Y
	CPI  R26,LOW(0x3)
	BRNE _0xC6
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x9)
	BRNE _0xC7
	RCALL _Left
	RJMP _0xC8
_0xC7:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x6)
	BRNE _0xC9
	RCALL _Right
	RJMP _0xCA
_0xC9:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0xC)
	BRNE _0xCB
	RCALL _Back
	RJMP _0xCC
_0xCB:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x2)
	BRNE _0xCD
	RCALL _Right_45
	RJMP _0xCE
_0xCD:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x1)
	BREQ _0x4EA
	CPI  R26,LOW(0x4)
	BRNE _0xD1
	CALL SUBOPT_0xE
	RJMP _0xD2
_0xD1:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x8)
	BRNE _0xD3
	RCALL _Left
_0x4EA:
	RCALL _Left_45
_0xD3:
_0xD2:
_0xCE:
_0xCC:
_0xCA:
_0xC8:
	LDI  R30,LOW(3)
	RJMP _0x4E4
_0xC6:
	LD   R26,Y
	CPI  R26,LOW(0x6)
	BRNE _0xD5
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x3)
	BRNE _0xD6
	RCALL _Left
	RJMP _0xD7
_0xD6:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0xC)
	BRNE _0xD8
	RCALL _Right
	RJMP _0xD9
_0xD8:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x9)
	BRNE _0xDA
	RCALL _Back
	RJMP _0xDB
_0xDA:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x4)
	BRNE _0xDC
	RCALL _Right_45
	RJMP _0xDD
_0xDC:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x2)
	BREQ _0x4EB
	CPI  R26,LOW(0x8)
	BRNE _0xE0
	CALL SUBOPT_0xE
	RJMP _0xE1
_0xE0:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x1)
	BRNE _0xE2
	RCALL _Left
_0x4EB:
	RCALL _Left_45
_0xE2:
_0xE1:
_0xDD:
_0xDB:
_0xD9:
_0xD7:
	LDI  R30,LOW(6)
_0x4E4:
	STS  _Angle_Robot,R30
_0xD5:
_0x2080007:
	ADIW R28,1
	RET
;	DRG -> Y+0
_Update:
	CALL SUBOPT_0xF
_0xFF:
	CALL SUBOPT_0x10
	BRSH _0x100
	CALL SUBOPT_0x11
_0x102:
	CALL SUBOPT_0x12
	SBIW R26,16
	BRSH _0x103
	CALL SUBOPT_0x13
	LDI  R30,LOW(255)
	ST   X,R30
	CALL SUBOPT_0x14
	RJMP _0x102
_0x103:
	CALL SUBOPT_0x15
	RJMP _0xFF
_0x100:
	CALL SUBOPT_0x16
	STS  _IndexA,R30
_0x105:
	LDS  R26,_IndexA
	CPI  R26,LOW(0xFC)
	BRLO PC+3
	JMP _0x106
	LDI  R30,LOW(0)
	STS  _i,R30
	STS  _i+1,R30
_0x108:
	CALL SUBOPT_0x10
	BRLO PC+3
	JMP _0x109
	CALL SUBOPT_0x11
_0x10B:
	CALL SUBOPT_0x12
	SBIW R26,16
	BRLO PC+3
	JMP _0x10C
	CALL SUBOPT_0x13
	LD   R26,X
	LDS  R30,_IndexA
	CP   R30,R26
	BREQ PC+3
	JMP _0x10D
	CALL SUBOPT_0x17
	CALL SUBOPT_0x18
	CALL SUBOPT_0x19
	BRNE _0x10E
	CALL SUBOPT_0x17
	CALL SUBOPT_0x1A
	LD   R26,X
	CPI  R26,LOW(0xFF)
	BRNE _0x10F
	CALL SUBOPT_0x17
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x1B
_0x10F:
_0x10E:
	CALL SUBOPT_0x17
	CALL SUBOPT_0x18
	CALL SUBOPT_0x1C
	BRNE _0x110
	CALL SUBOPT_0x1D
	LD   R26,X
	CPI  R26,LOW(0xFF)
	BRNE _0x111
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1B
_0x111:
_0x110:
	CALL SUBOPT_0x17
	CALL SUBOPT_0x18
	CALL SUBOPT_0x1E
	BRNE _0x112
	CALL SUBOPT_0x1F
	LD   R26,X
	CPI  R26,LOW(0xFF)
	BRNE _0x113
	CALL SUBOPT_0x1F
	CALL SUBOPT_0x1B
_0x113:
_0x112:
	CALL SUBOPT_0x17
	CALL SUBOPT_0x18
	CALL SUBOPT_0x20
	BRNE _0x114
	CALL SUBOPT_0x17
	CALL SUBOPT_0x21
	LD   R26,X
	CPI  R26,LOW(0xFF)
	BRNE _0x115
	CALL SUBOPT_0x17
	CALL SUBOPT_0x21
	CALL SUBOPT_0x1B
_0x115:
_0x114:
_0x10D:
	CALL SUBOPT_0x14
	RJMP _0x10B
_0x10C:
	CALL SUBOPT_0x15
	RJMP _0x108
_0x109:
	LDS  R30,_Switch
	CPI  R30,0
	BRNE _0x116
	LDI  R30,LOW(251)
	STS  _IndexA,R30
	RJMP _0x117
_0x116:
	LDI  R30,LOW(0)
	STS  _Switch,R30
_0x117:
	LDS  R30,_IndexA
	SUBI R30,-LOW(1)
	STS  _IndexA,R30
	RJMP _0x105
_0x106:
	RET
_Update_Ver3:
	CALL SUBOPT_0xF
_0x119:
	CALL SUBOPT_0x10
	BRSH _0x11A
	CALL SUBOPT_0x11
_0x11C:
	CALL SUBOPT_0x12
	SBIW R26,16
	BRSH _0x11D
	CALL SUBOPT_0x13
	LDI  R30,LOW(255)
	ST   X,R30
	CALL SUBOPT_0x14
	RJMP _0x11C
_0x11D:
	CALL SUBOPT_0x15
	RJMP _0x119
_0x11A:
	CALL SUBOPT_0x16
	STS  _Home_Update3,R30
	LDS  R30,_Finish_Home_1
	__PUTB1MN _Home_Update3,1
	__GETB1MN _Finish_Home_1,1
	__PUTB1MN _Home_Update3,2
	LDI  R30,LOW(0)
	__PUTB1MN _Home_Update3,3
	LDS  R30,_Finish_Home_2
	__PUTB1MN _Home_Update3,4
	__GETB1MN _Finish_Home_2,1
	__PUTB1MN _Home_Update3,5
	LDI  R30,LOW(0)
	__PUTB1MN _Home_Update3,6
	LDS  R30,_Finish_Home_3
	__PUTB1MN _Home_Update3,7
	__GETB1MN _Finish_Home_3,1
	__PUTB1MN _Home_Update3,8
	LDI  R30,LOW(0)
	__PUTB1MN _Home_Update3,9
	LDS  R30,_Finish_Home_4
	__PUTB1MN _Home_Update3,10
	__GETB1MN _Finish_Home_4,1
	__PUTB1MN _Home_Update3,11
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	STS  _j,R30
	STS  _j+1,R31
	LDI  R30,LOW(0)
	STS  _l,R30
	STS  _l+1,R30
_0x11E:
	CALL SUBOPT_0x12
	CPI  R26,LOW(0xFF)
	LDI  R30,HIGH(0xFF)
	CPC  R27,R30
	BRSH _0x121
	LDS  R30,_j
	LDS  R31,_j+1
	LDS  R26,_l
	LDS  R27,_l+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x122
_0x121:
	RJMP _0x120
_0x122:
	LDS  R26,_l
	LDS  R27,_l+1
	CALL SUBOPT_0x22
	STS  _i,R30
	STS  _i+1,R31
	CALL SUBOPT_0x23
	CALL SUBOPT_0x24
	CALL SUBOPT_0x19
	BRNE _0x123
	CALL SUBOPT_0x23
	CALL SUBOPT_0x25
	CALL SUBOPT_0x26
	BRNE _0x124
	CALL SUBOPT_0x14
	CALL SUBOPT_0x27
	CALL SUBOPT_0x28
	CALL SUBOPT_0x29
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x2B
	CALL SUBOPT_0x2C
	CALL __LSLW4
	CALL SUBOPT_0x25
	CALL SUBOPT_0x2D
_0x124:
_0x123:
	CALL SUBOPT_0x23
	CALL SUBOPT_0x24
	CALL SUBOPT_0x1C
	BRNE _0x125
	CALL SUBOPT_0x2B
	CALL SUBOPT_0x2E
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x30
	BRNE _0x126
	CALL SUBOPT_0x14
	CALL SUBOPT_0x27
	CALL SUBOPT_0x28
	SUBI R30,-LOW(1)
	CALL SUBOPT_0x29
	CALL SUBOPT_0x31
	CALL SUBOPT_0x2C
	CALL SUBOPT_0x2F
	LDI  R31,0
	CALL SUBOPT_0x2D
_0x126:
_0x125:
	CALL SUBOPT_0x23
	CALL SUBOPT_0x24
	CALL SUBOPT_0x20
	BRNE _0x127
	CALL SUBOPT_0x23
	CALL SUBOPT_0x32
	CALL SUBOPT_0x26
	BRNE _0x128
	CALL SUBOPT_0x14
	CALL SUBOPT_0x27
	CALL SUBOPT_0x28
	CALL SUBOPT_0x29
	CALL SUBOPT_0x33
	CALL SUBOPT_0x31
	CALL SUBOPT_0x2C
	CALL __LSLW4
	CALL SUBOPT_0x32
	CALL SUBOPT_0x2D
_0x128:
_0x127:
	CALL SUBOPT_0x23
	CALL SUBOPT_0x24
	CALL SUBOPT_0x1E
	BRNE _0x129
	CALL SUBOPT_0x2B
	CALL SUBOPT_0x2E
	CALL SUBOPT_0x34
	CALL SUBOPT_0x30
	BRNE _0x12A
	CALL SUBOPT_0x14
	CALL SUBOPT_0x27
	CALL SUBOPT_0x28
	CALL SUBOPT_0x33
	CALL SUBOPT_0x29
	CALL SUBOPT_0x31
	CALL SUBOPT_0x2C
	CALL SUBOPT_0x34
	LDI  R31,0
	CALL SUBOPT_0x2D
_0x12A:
_0x129:
	LDI  R26,LOW(_l)
	LDI  R27,HIGH(_l)
	CALL SUBOPT_0x35
	RJMP _0x11E
_0x120:
	RET
_Move_Robot_Speed:
	CALL SUBOPT_0x3
	CALL SUBOPT_0x4
	ORI  R30,0x80
	ST   X,R30
_0x12B:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x8)
	BREQ PC+3
	JMP _0x12D
	CALL SUBOPT_0x36
	CALL SUBOPT_0x4
	CALL SUBOPT_0x37
	BRNE _0x12F
	CALL SUBOPT_0x3
	CALL SUBOPT_0x38
	CALL SUBOPT_0x39
	CALL SUBOPT_0x38
	CALL SUBOPT_0x3A
	BRLO _0x130
_0x12F:
	RJMP _0x12E
_0x130:
	CALL SUBOPT_0x3B
	RJMP _0x2080005
_0x12E:
	CALL SUBOPT_0x3C
	CALL SUBOPT_0x4
	CALL SUBOPT_0x37
	BRNE _0x132
	CALL SUBOPT_0x3
	CALL SUBOPT_0x38
	CALL SUBOPT_0x39
	ADIW R30,1
	CALL SUBOPT_0x38
	CALL SUBOPT_0x3D
	BRLO _0x133
_0x132:
	RJMP _0x131
_0x133:
	CALL SUBOPT_0x3E
	RJMP _0x2080005
_0x131:
	CALL SUBOPT_0x3F
	CALL SUBOPT_0x4
	CALL SUBOPT_0x37
	BRNE _0x135
	CALL SUBOPT_0x3
	CALL SUBOPT_0x38
	CALL SUBOPT_0x39
	SBIW R30,1
	CALL SUBOPT_0x38
	CALL SUBOPT_0x3D
	BRLO _0x136
_0x135:
	RJMP _0x134
_0x136:
	RJMP _0x2080006
_0x134:
	CALL SUBOPT_0x40
	CALL SUBOPT_0x4
	CALL SUBOPT_0x37
	BRNE _0x138
	CALL SUBOPT_0x3
	CALL SUBOPT_0x38
	CALL SUBOPT_0x39
	CALL SUBOPT_0x41
	CALL SUBOPT_0x3D
	BRLO _0x139
_0x138:
	RJMP _0x137
_0x139:
	CALL SUBOPT_0x42
	__PUTB1MN _Index_Robot,1
	LDI  R30,LOW(2)
	RJMP _0x2080005
_0x137:
	RCALL _Update_Ver3
	RJMP _0x12B
_0x12D:
_0x13A:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x4)
	BREQ PC+3
	JMP _0x13C
	CALL SUBOPT_0x3C
	CALL SUBOPT_0x4
	CALL SUBOPT_0x37
	BRNE _0x13E
	CALL SUBOPT_0x3
	CALL SUBOPT_0x38
	CALL SUBOPT_0x39
	ADIW R30,1
	CALL SUBOPT_0x38
	CALL SUBOPT_0x3D
	BRLO _0x13F
_0x13E:
	RJMP _0x13D
_0x13F:
	CALL SUBOPT_0x3E
	RJMP _0x2080005
_0x13D:
	CALL SUBOPT_0x36
	CALL SUBOPT_0x4
	CALL SUBOPT_0x37
	BRNE _0x141
	CALL SUBOPT_0x3
	CALL SUBOPT_0x38
	CALL SUBOPT_0x39
	CALL SUBOPT_0x38
	CALL SUBOPT_0x3A
	BRLO _0x142
_0x141:
	RJMP _0x140
_0x142:
	CALL SUBOPT_0x3B
	RJMP _0x2080005
_0x140:
	CALL SUBOPT_0x3F
	CALL SUBOPT_0x4
	CALL SUBOPT_0x37
	BRNE _0x144
	CALL SUBOPT_0x3
	CALL SUBOPT_0x38
	CALL SUBOPT_0x39
	SBIW R30,1
	CALL SUBOPT_0x38
	CALL SUBOPT_0x3D
	BRLO _0x145
_0x144:
	RJMP _0x143
_0x145:
	RJMP _0x2080006
_0x143:
	CALL SUBOPT_0x40
	CALL SUBOPT_0x4
	CALL SUBOPT_0x37
	BRNE _0x147
	CALL SUBOPT_0x3
	CALL SUBOPT_0x38
	CALL SUBOPT_0x39
	CALL SUBOPT_0x41
	CALL SUBOPT_0x3D
	BRLO _0x148
_0x147:
	RJMP _0x146
_0x148:
	CALL SUBOPT_0x42
	__PUTB1MN _Index_Robot,1
	LDI  R30,LOW(2)
	RJMP _0x2080005
_0x146:
	RCALL _Update_Ver3
	RJMP _0x13A
_0x13C:
_0x149:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0x14B
	CALL SUBOPT_0x3F
	CALL SUBOPT_0x4
	CALL SUBOPT_0x37
	BRNE _0x14D
	CALL SUBOPT_0x3
	CALL SUBOPT_0x38
	CALL SUBOPT_0x39
	SBIW R30,1
	CALL SUBOPT_0x38
	CALL SUBOPT_0x3D
	BRLO _0x14E
_0x14D:
	RJMP _0x14C
_0x14E:
	RJMP _0x2080006
_0x14C:
	CALL SUBOPT_0x36
	CALL SUBOPT_0x4
	CALL SUBOPT_0x37
	BRNE _0x150
	CALL SUBOPT_0x3
	CALL SUBOPT_0x38
	CALL SUBOPT_0x39
	CALL SUBOPT_0x38
	CALL SUBOPT_0x3A
	BRLO _0x151
_0x150:
	RJMP _0x14F
_0x151:
	CALL SUBOPT_0x3B
	RJMP _0x2080005
_0x14F:
	CALL SUBOPT_0x3C
	CALL SUBOPT_0x4
	CALL SUBOPT_0x37
	BRNE _0x153
	CALL SUBOPT_0x3
	CALL SUBOPT_0x38
	CALL SUBOPT_0x39
	ADIW R30,1
	CALL SUBOPT_0x38
	CALL SUBOPT_0x3D
	BRLO _0x154
_0x153:
	RJMP _0x152
_0x154:
	CALL SUBOPT_0x3E
	RJMP _0x2080005
_0x152:
	CALL SUBOPT_0x40
	CALL SUBOPT_0x4
	CALL SUBOPT_0x37
	BRNE _0x156
	CALL SUBOPT_0x3
	CALL SUBOPT_0x38
	CALL SUBOPT_0x39
	CALL SUBOPT_0x41
	CALL SUBOPT_0x3D
	BRLO _0x157
_0x156:
	RJMP _0x155
_0x157:
	CALL SUBOPT_0x42
	__PUTB1MN _Index_Robot,1
	LDI  R30,LOW(2)
	RJMP _0x2080005
_0x155:
	RCALL _Update_Ver3
	RJMP _0x149
_0x14B:
_0x158:
	LDS  R26,_Angle_Robot
	CPI  R26,LOW(0x2)
	BREQ PC+3
	JMP _0x15A
	CALL SUBOPT_0x40
	CALL SUBOPT_0x4
	CALL SUBOPT_0x37
	BRNE _0x15C
	CALL SUBOPT_0x3
	CALL SUBOPT_0x38
	CALL SUBOPT_0x39
	CALL SUBOPT_0x41
	CALL SUBOPT_0x3D
	BRLO _0x15D
_0x15C:
	RJMP _0x15B
_0x15D:
	CALL SUBOPT_0x42
	__PUTB1MN _Index_Robot,1
	LDI  R30,LOW(2)
	RJMP _0x2080005
_0x15B:
	CALL SUBOPT_0x3C
	CALL SUBOPT_0x4
	CALL SUBOPT_0x37
	BRNE _0x15F
	CALL SUBOPT_0x3
	CALL SUBOPT_0x38
	CALL SUBOPT_0x39
	ADIW R30,1
	CALL SUBOPT_0x38
	CALL SUBOPT_0x3D
	BRLO _0x160
_0x15F:
	RJMP _0x15E
_0x160:
	CALL SUBOPT_0x3E
	RJMP _0x2080005
_0x15E:
	CALL SUBOPT_0x36
	CALL SUBOPT_0x4
	CALL SUBOPT_0x37
	BRNE _0x162
	CALL SUBOPT_0x3
	CALL SUBOPT_0x38
	CALL SUBOPT_0x39
	CALL SUBOPT_0x38
	CALL SUBOPT_0x3A
	BRLO _0x163
_0x162:
	RJMP _0x161
_0x163:
	CALL SUBOPT_0x3B
	RJMP _0x2080005
_0x161:
	CALL SUBOPT_0x3F
	CALL SUBOPT_0x4
	CALL SUBOPT_0x37
	BRNE _0x165
	CALL SUBOPT_0x3
	CALL SUBOPT_0x38
	CALL SUBOPT_0x39
	SBIW R30,1
	CALL SUBOPT_0x38
	CALL SUBOPT_0x3D
	BRLO _0x166
_0x165:
	RJMP _0x164
_0x166:
_0x2080006:
	LDS  R30,_Index_Robot
	CALL SUBOPT_0x33
	STS  _Index_Robot,R30
	LDI  R30,LOW(1)
_0x2080005:
	ST   -Y,R30
	RCALL _Darage
	RET
_0x164:
	RCALL _Update_Ver3
	RJMP _0x158
_0x15A:
	RET
;	And -> R17
_Go_To_Center_Point:
	LDS  R26,_Index_Robot_Point
	CPI  R26,LOW(0x1)
	BRNE _0x2C2
	LDI  R30,LOW(2)
	RJMP _0x4ED
_0x2C2:
	LDS  R26,_Index_Robot_Point
	CPI  R26,LOW(0x2)
	BRNE _0x2C4
	LDI  R30,LOW(8)
	RJMP _0x4ED
_0x2C4:
	LDS  R26,_Index_Robot_Point
	CPI  R26,LOW(0x4)
	BRNE _0x2C6
	LDI  R30,LOW(1)
	RJMP _0x4ED
_0x2C6:
	LDS  R26,_Index_Robot_Point
	CPI  R26,LOW(0x8)
	BRNE _0x2C8
	LDI  R30,LOW(4)
_0x4ED:
	ST   -Y,R30
	RCALL _Darage
_0x2C8:
	RCALL _Front_Half_Size_Home
	LDI  R30,LOW(15)
	STS  _Index_Robot_Point,R30
	RET
_Finish:
	LDS  R30,_Finish_Home_1
	LDS  R26,_Index_Robot
	CP   R30,R26
	BREQ _0x2CA
	LDS  R30,_Finish_Home_2
	CP   R30,R26
	BREQ _0x2CA
	LDS  R30,_Finish_Home_3
	CP   R30,R26
	BREQ _0x2CA
	LDS  R30,_Finish_Home_4
	CP   R30,R26
	BREQ _0x2CA
	RJMP _0x2C9
_0x2CA:
	__GETB2MN _Index_Robot,1
	__GETB1MN _Finish_Home_1,1
	CP   R30,R26
	BREQ _0x2CD
	__GETB2MN _Index_Robot,1
	__GETB1MN _Finish_Home_2,1
	CP   R30,R26
	BREQ _0x2CD
	__GETB2MN _Index_Robot,1
	__GETB1MN _Finish_Home_3,1
	CP   R30,R26
	BREQ _0x2CD
	__GETB2MN _Index_Robot,1
	__GETB1MN _Finish_Home_4,1
	CP   R30,R26
	BREQ _0x2CD
	RJMP _0x2CC
_0x2CD:
	LDS  R26,_Model_Move
	CPI  R26,LOW(0x1)
	BRNE _0x2CF
	RCALL _Go_To_Center_Point
_0x2CF:
	RCALL _Save
	LDS  R26,_Check_Home_Finish
	CPI  R26,LOW(0x1)
	BRNE _0x2D0
	LDS  R26,_Back_Way
	CPI  R26,LOW(0x5)
	BRNE _0x2D1
	LDI  R30,LOW(0)
	RJMP _0x4EE
_0x2D1:
	LDI  R30,LOW(5)
_0x4EE:
	STS  _Back_Way,R30
	RJMP _0x2D3
_0x2D0:
	LDS  R30,_Back_Way
	SUBI R30,-LOW(1)
	STS  _Back_Way,R30
	LDS  R26,_Index_Robot
	CPI  R26,LOW(0x7)
	BRNE _0x2D5
	__GETB2MN _Index_Robot,1
	CPI  R26,LOW(0x7)
	BREQ _0x2D6
_0x2D5:
	RJMP _0x2D4
_0x2D6:
	LDI  R30,LOW(2)
	STS  _Back_Way,R30
_0x2D4:
_0x2D3:
	LDS  R30,_Len_Way
	LDS  R26,_Len_Way_A
	CP   R30,R26
	BREQ _0x2D7
	STS  _Len_Way_A,R30
	LDI  R30,LOW(0)
	RJMP _0x4EF
_0x2D7:
	LDI  R30,LOW(1)
_0x4EF:
	STS  _Small_Len_Way,R30
	LDI  R30,LOW(0)
	STS  _Len_Way,R30
	LDS  R26,_Back_Way
	CPI  R26,LOW(0x6)
	BRNE _0x2D9
	STS  _Back_Way,R30
_0x2D9:
	LDS  R30,_Back_Way
	CPI  R30,0
	BRNE _0x2DA
	CALL SUBOPT_0x43
	CALL SUBOPT_0x44
	CALL SUBOPT_0x45
	CALL SUBOPT_0x46
	RJMP _0x2DB
_0x2DA:
	LDS  R26,_Back_Way
	CPI  R26,LOW(0x1)
	BRNE _0x2DC
	CALL SUBOPT_0x43
	LDI  R30,LOW(7)
	STS  _Finish_Home_2,R30
	__PUTB1MN _Finish_Home_2,1
	STS  _Finish_Home_3,R30
	__PUTB1MN _Finish_Home_3,1
	STS  _Finish_Home_4,R30
	__PUTB1MN _Finish_Home_4,1
	RJMP _0x2DD
_0x2DC:
	LDS  R26,_Back_Way
	CPI  R26,LOW(0x2)
	BRNE _0x2DE
	LDI  R30,LOW(7)
	STS  _Finish_Home_1,R30
	LDI  R30,LOW(8)
	__PUTB1MN _Finish_Home_1,1
	LDI  R30,LOW(7)
	STS  _Finish_Home_2,R30
	LDI  R30,LOW(8)
	__PUTB1MN _Finish_Home_2,1
	CALL SUBOPT_0x45
	LDI  R30,LOW(7)
	STS  _Finish_Home_4,R30
	LDI  R30,LOW(8)
	__PUTB1MN _Finish_Home_4,1
	RJMP _0x2DF
_0x2DE:
	LDS  R26,_Back_Way
	CPI  R26,LOW(0x3)
	BRNE _0x2E0
	LDI  R30,LOW(8)
	STS  _Finish_Home_1,R30
	__PUTB1MN _Finish_Home_1,1
	STS  _Finish_Home_2,R30
	__PUTB1MN _Finish_Home_2,1
	STS  _Finish_Home_3,R30
	__PUTB1MN _Finish_Home_3,1
	CALL SUBOPT_0x46
	RJMP _0x2E1
_0x2E0:
	LDS  R26,_Back_Way
	CPI  R26,LOW(0x4)
	BRNE _0x2E2
	LDI  R30,LOW(8)
	STS  _Finish_Home_1,R30
	LDI  R30,LOW(7)
	__PUTB1MN _Finish_Home_1,1
	CALL SUBOPT_0x44
	LDI  R30,LOW(8)
	STS  _Finish_Home_3,R30
	LDI  R30,LOW(7)
	__PUTB1MN _Finish_Home_3,1
	LDI  R30,LOW(8)
	STS  _Finish_Home_4,R30
	LDI  R30,LOW(7)
	__PUTB1MN _Finish_Home_4,1
	RJMP _0x2E3
_0x2E2:
	LDS  R26,_Back_Way
	CPI  R26,LOW(0x5)
	BRNE _0x2E4
	LDI  R30,LOW(0)
	STS  _Finish_Home_1,R30
	__PUTB1MN _Finish_Home_1,1
	STS  _Finish_Home_2,R30
	__PUTB1MN _Finish_Home_2,1
	STS  _Finish_Home_3,R30
	__PUTB1MN _Finish_Home_3,1
	STS  _Finish_Home_4,R30
	__PUTB1MN _Finish_Home_4,1
	LDI  R30,LOW(1)
	STS  _Check_Home_Finish,R30
_0x2E4:
_0x2E3:
_0x2E1:
_0x2DF:
_0x2DD:
_0x2DB:
	RCALL _Update
_0x2CC:
_0x2C9:
	RET
;	Counter_i -> R17
;	Counter_j -> R16
;	And -> R17
_Go_Speed:
	RCALL _Check_Wall
	RCALL _Move_Robot_Speed
	RCALL _Front
	LDS  R30,_Len_Way
	SUBI R30,-LOW(1)
	STS  _Len_Way,R30
	RCALL _Finish
	RET
;#include <..\Maze_Alguritm\Need_Maze.h>
_Enable_Motor:
	SBI  0x12,6
	SBI  0x12,1
	LDI  R30,LOW(2)
	OUT  0x33,R30
	RET
_Enable_Sensor:
	LDI  R30,LOW(1)
	OUT  0x2E,R30
	RET
_Disable_Sensor:
	LDI  R30,LOW(0)
	OUT  0x2E,R30
	IN   R30,0x15
	ANDI R30,LOW(0xE0)
	OUT  0x15,R30
	RET
_Lock:
;	AMotor -> Y+0
	LDI  R30,LOW(0)
	STS  _Speed_Right_Motor,R30
	STS  _Speed_Left_Motor,R30
	LD   R30,Y
	STS  _Acceleration_Motor,R30
	LDS  R26,_Wheel_Left_Motor
	CPI  R26,LOW(0x4)
	BRNE _0x48C
	LDI  R30,LOW(1)
	RJMP _0x506
_0x48C:
	LDI  R30,LOW(4)
_0x506:
	STS  _Wheel_Left_Motor,R30
	LDS  R26,_Wheel_Right_Motor
	CPI  R26,LOW(0x4)
	BRNE _0x48E
	LDI  R30,LOW(1)
	RJMP _0x507
_0x48E:
	LDI  R30,LOW(4)
_0x507:
	STS  _Wheel_Right_Motor,R30
	ADIW R28,1
	RET
_Correction:
	LDS  R30,_Max_FCS
	LDS  R31,_Max_FCS+1
	CALL SUBOPT_0x47
	BRLO _0x490
	LDS  R30,_Center_FCS
	LDS  R31,_Center_FCS+1
	CALL SUBOPT_0x47
	BRLO _0x491
	LDI  R30,LOW(325)
	LDI  R31,HIGH(325)
	MOVW R8,R30
	MOVW R10,R30
	RJMP _0x492
_0x491:
	CALL SUBOPT_0x48
_0x492:
	RJMP _0x493
_0x490:
	LDS  R30,_Center_RS
	LDS  R31,_Center_RS+1
	ADIW R30,2
	CALL SUBOPT_0x49
	BRSH _0x494
	STS  _Speed_Right_Motor,R5
	MOV  R30,R4
	CALL SUBOPT_0x33
	STS  _Speed_Left_Motor,R30
	RJMP _0x495
_0x494:
	LDS  R30,_Center_LS
	LDS  R31,_Center_LS+1
	ADIW R30,2
	CALL SUBOPT_0x4A
	BRSH _0x496
	STS  _Speed_Left_Motor,R4
	MOV  R30,R5
	CALL SUBOPT_0x33
	STS  _Speed_Right_Motor,R30
	RJMP _0x497
_0x496:
	LDS  R30,_Max_RS
	LDS  R31,_Max_RS+1
	CALL SUBOPT_0x49
	BRSH _0x498
	STS  _Speed_Left_Motor,R4
	MOV  R30,R5
	CALL SUBOPT_0x33
	STS  _Speed_Right_Motor,R30
	RJMP _0x499
_0x498:
	LDS  R30,_Max_LS
	LDS  R31,_Max_LS+1
	CALL SUBOPT_0x4A
	BRSH _0x49A
	STS  _Speed_Right_Motor,R5
	MOV  R30,R4
	CALL SUBOPT_0x33
	STS  _Speed_Left_Motor,R30
	RJMP _0x49B
_0x49A:
	CALL SUBOPT_0x4B
_0x49B:
_0x499:
_0x497:
_0x495:
_0x493:
	RET
_Front_Half_Size_Home:
	RET
_Right_45:
	RET
_Left_45:
	RET
_Front:
	SBI  0x15,5
	CALL SUBOPT_0x48
	LDI  R30,LOW(4)
	CALL SUBOPT_0x4C
	LDI  R30,LOW(1)
	STS  _Acceleration_Motor,R30
_0x49E:
	MOVW R26,R10
	ADD  R26,R8
	ADC  R27,R9
	CPI  R26,LOW(0x145)
	LDI  R30,HIGH(0x145)
	CPC  R27,R30
	BRSH _0x4A0
	RCALL _Correction
	RJMP _0x49E
_0x4A0:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _Lock
	CBI  0x15,5
	RET
_Back:
	RCALL _Right
	RCALL _Right
	RET
_Right:
	CALL SUBOPT_0x48
	LDI  R30,LOW(1)
	CALL SUBOPT_0x4C
	LDI  R30,LOW(1)
	STS  _Acceleration_Motor,R30
_0x4A3:
	MOVW R26,R10
	ADD  R26,R8
	ADC  R27,R9
	CPI  R26,LOW(0x64)
	LDI  R30,HIGH(0x64)
	CPC  R27,R30
	BRLO _0x4A3
	RJMP _0x2080004
_Left:
	CALL SUBOPT_0x48
	LDI  R30,LOW(4)
	STS  _Wheel_Right_Motor,R30
	LDI  R30,LOW(1)
	STS  _Wheel_Left_Motor,R30
	CALL SUBOPT_0x4B
	LDI  R30,LOW(1)
	STS  _Acceleration_Motor,R30
_0x4A6:
	MOVW R26,R10
	ADD  R26,R8
	ADC  R27,R9
	CPI  R26,LOW(0x50)
	LDI  R30,HIGH(0x50)
	CPC  R27,R30
	BRLO _0x4A6
_0x2080004:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _Lock
	RET
_Read_Sensor:
;	Namber_Sensor_Wall -> Y+0
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0x4A9
	LDS  R30,_Max_RS
	LDS  R31,_Max_RS+1
	LDS  R26,_ValueRS
	LDS  R27,_ValueRS+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x4AA
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	JMP  _0x2080001
_0x4AA:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	JMP  _0x2080001
_0x4A9:
	LD   R26,Y
	CPI  R26,LOW(0x2)
	BRNE _0x4AD
	LDS  R30,_Max_FRS
	LDS  R31,_Max_FRS+1
	LDS  R26,_ValueFRS
	LDS  R27,_ValueFRS+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x4AF
	LDS  R30,_Max_FLS
	LDS  R31,_Max_FLS+1
	LDS  R26,_ValueFLS
	LDS  R27,_ValueFLS+1
	CP   R26,R30
	CPC  R27,R31
	BRSH _0x4B0
_0x4AF:
	RJMP _0x4AE
_0x4B0:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	JMP  _0x2080001
_0x4AE:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	JMP  _0x2080001
_0x4AD:
	LD   R26,Y
	CPI  R26,LOW(0x3)
	BRNE _0x4B3
	LDS  R30,_Max_LS
	LDS  R31,_Max_LS+1
	LDS  R26,_ValueLS
	LDS  R27,_ValueLS+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x4B4
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	JMP  _0x2080001
_0x4B4:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	JMP  _0x2080001
_0x4B3:
	JMP  _0x2080001
;#include <..\Jerry_6\Load_Save_Map.h>
_Save:
	LDI  R30,LOW(0)
	STS  _ik,R30
_0x4B7:
	LDS  R26,_ik
	CPI  R26,LOW(0x10)
	BRSH _0x4B8
	LDI  R30,LOW(0)
	STS  _jk,R30
_0x4BA:
	LDS  R26,_jk
	CPI  R26,LOW(0x10)
	BRSH _0x4BB
	LDS  R30,_ik
	LDI  R31,0
	CALL __LSLW4
	MOVW R22,R30
	SUBI R30,LOW(-_EPR_Wall_Homes)
	SBCI R31,HIGH(-_EPR_Wall_Homes)
	MOVW R26,R30
	LDS  R30,_jk
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOVW R26,R22
	SUBI R26,LOW(-_Wall_Homes)
	SBCI R27,HIGH(-_Wall_Homes)
	LDS  R30,_jk
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	MOVW R26,R0
	CALL __EEPROMWRB
	LDS  R30,_jk
	SUBI R30,-LOW(1)
	STS  _jk,R30
	RJMP _0x4BA
_0x4BB:
	LDS  R30,_ik
	SUBI R30,-LOW(1)
	STS  _ik,R30
	RJMP _0x4B7
_0x4B8:
	RET
_Load_Config:
	LDI  R26,LOW(_EPR_Center_FCS)
	LDI  R27,HIGH(_EPR_Center_FCS)
	CALL __EEPROMRDW
	STS  _Center_FCS,R30
	STS  _Center_FCS+1,R31
	LDI  R26,LOW(_EPR_Max_FCS)
	LDI  R27,HIGH(_EPR_Max_FCS)
	CALL __EEPROMRDW
	STS  _Max_FCS,R30
	STS  _Max_FCS+1,R31
	LDI  R26,LOW(_EPR_Center_FRS)
	LDI  R27,HIGH(_EPR_Center_FRS)
	CALL __EEPROMRDW
	STS  _Center_FRS,R30
	STS  _Center_FRS+1,R31
	LDI  R26,LOW(_EPR_Max_FRS)
	LDI  R27,HIGH(_EPR_Max_FRS)
	CALL __EEPROMRDW
	STS  _Max_FRS,R30
	STS  _Max_FRS+1,R31
	LDI  R26,LOW(_EPR_Center_FLS)
	LDI  R27,HIGH(_EPR_Center_FLS)
	CALL __EEPROMRDW
	STS  _Center_FLS,R30
	STS  _Center_FLS+1,R31
	LDI  R26,LOW(_EPR_Max_FLS)
	LDI  R27,HIGH(_EPR_Max_FLS)
	CALL __EEPROMRDW
	STS  _Max_FLS,R30
	STS  _Max_FLS+1,R31
	LDI  R26,LOW(_EPR_Center_RS)
	LDI  R27,HIGH(_EPR_Center_RS)
	CALL __EEPROMRDW
	STS  _Center_RS,R30
	STS  _Center_RS+1,R31
	LDI  R26,LOW(_EPR_Max_RS)
	LDI  R27,HIGH(_EPR_Max_RS)
	CALL __EEPROMRDW
	STS  _Max_RS,R30
	STS  _Max_RS+1,R31
	LDI  R26,LOW(_EPR_Min_RS)
	LDI  R27,HIGH(_EPR_Min_RS)
	CALL __EEPROMRDW
	STS  _Min_RS,R30
	STS  _Min_RS+1,R31
	LDI  R26,LOW(_EPR_Center_LS)
	LDI  R27,HIGH(_EPR_Center_LS)
	CALL __EEPROMRDW
	STS  _Center_LS,R30
	STS  _Center_LS+1,R31
	LDI  R26,LOW(_EPR_Max_LS)
	LDI  R27,HIGH(_EPR_Max_LS)
	CALL __EEPROMRDW
	STS  _Max_LS,R30
	STS  _Max_LS+1,R31
	LDI  R26,LOW(_EPR_Min_LS)
	LDI  R27,HIGH(_EPR_Min_LS)
	CALL __EEPROMRDW
	STS  _Min_LS,R30
	STS  _Min_LS+1,R31
	LDS  R26,_Max_FRS
	LDS  R27,_Max_FRS+1
	LDS  R30,_Center_FRS
	LDS  R31,_Center_FRS+1
	SUB  R30,R26
	SBC  R31,R27
	LSR  R31
	ROR  R30
	STS  _AMCFSR,R30
	STS  _AMCFSR+1,R31
	LDS  R26,_Max_FLS
	LDS  R27,_Max_FLS+1
	LDS  R30,_Center_FLS
	LDS  R31,_Center_FLS+1
	SUB  R30,R26
	SBC  R31,R27
	LSR  R31
	ROR  R30
	STS  _AMCFSL,R30
	STS  _AMCFSL+1,R31
	RET
_Setup_Jerr_7:
	LDI  R30,LOW(5)
	STS  _Accuracy_Sensor,R30
	CALL _lcd_clear
	CALL SUBOPT_0x4D
	__POINTW1FN _0x0,0
	CALL SUBOPT_0x4E
	LDI  R30,LOW(0)
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x50
	__POINTW1MN _0x4CE,0
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_puts
	CALL SUBOPT_0x51
	RCALL _Enable_Sensor
	CALL SUBOPT_0x52
	__POINTW1FN _0x0,21
	CALL SUBOPT_0x53
_0x4CF:
	SBIS 0x16,0
	RJMP _0x4D1
	CALL SUBOPT_0x4D
	CALL SUBOPT_0x54
	CALL SUBOPT_0x55
	CALL SUBOPT_0x56
	CALL SUBOPT_0x55
	CALL SUBOPT_0x57
	CALL SUBOPT_0x58
	RJMP _0x4CF
_0x4D1:
	LDS  R30,_ValueFCS
	LDS  R31,_ValueFCS+1
	LDI  R26,LOW(_EPR_Center_FCS)
	LDI  R27,HIGH(_EPR_Center_FCS)
	CALL SUBOPT_0x59
	LDI  R26,LOW(_EPR_Center_FRS)
	LDI  R27,HIGH(_EPR_Center_FRS)
	CALL SUBOPT_0x5A
	LDI  R26,LOW(_EPR_Center_FLS)
	LDI  R27,HIGH(_EPR_Center_FLS)
	CALL SUBOPT_0x5B
	CALL SUBOPT_0x52
	__POINTW1FN _0x0,86
	CALL SUBOPT_0x5C
_0x4D2:
	SBIS 0x16,0
	RJMP _0x4D4
	CALL SUBOPT_0x4D
	CALL SUBOPT_0x54
	CALL SUBOPT_0x55
	CALL SUBOPT_0x56
	CALL SUBOPT_0x55
	CALL SUBOPT_0x57
	CALL SUBOPT_0x55
	CALL SUBOPT_0x5D
	CALL SUBOPT_0x55
	CALL SUBOPT_0x5E
	CALL SUBOPT_0x58
	RJMP _0x4D2
_0x4D4:
	LDS  R30,_ValueFCS
	LDS  R31,_ValueFCS+1
	LDI  R26,LOW(_EPR_Max_FCS)
	LDI  R27,HIGH(_EPR_Max_FCS)
	CALL SUBOPT_0x59
	LDI  R26,LOW(_EPR_Max_FRS)
	LDI  R27,HIGH(_EPR_Max_FRS)
	CALL SUBOPT_0x5A
	LDI  R26,LOW(_EPR_Max_FLS)
	LDI  R27,HIGH(_EPR_Max_FLS)
	CALL SUBOPT_0x5F
	ADIW R30,3
	LDI  R26,LOW(_EPR_Center_RS)
	LDI  R27,HIGH(_EPR_Center_RS)
	CALL SUBOPT_0x60
	ADIW R30,3
	LDI  R26,LOW(_EPR_Center_LS)
	LDI  R27,HIGH(_EPR_Center_LS)
	CALL SUBOPT_0x5B
	CALL SUBOPT_0x52
	__POINTW1FN _0x0,107
	CALL SUBOPT_0x5C
_0x4D5:
	SBIS 0x16,0
	RJMP _0x4D7
	CALL SUBOPT_0x4D
	CALL SUBOPT_0x5E
	CALL SUBOPT_0x55
	CALL SUBOPT_0x5D
	CALL SUBOPT_0x58
	RJMP _0x4D5
_0x4D7:
	LDS  R30,_ValueLS
	LDS  R31,_ValueLS+1
	SBIW R30,1
	LDI  R26,LOW(_EPR_Max_LS)
	LDI  R27,HIGH(_EPR_Max_LS)
	CALL SUBOPT_0x5F
	LDI  R26,LOW(_EPR_Min_RS)
	LDI  R27,HIGH(_EPR_Min_RS)
	CALL SUBOPT_0x5B
	CALL SUBOPT_0x52
	__POINTW1FN _0x0,128
	CALL SUBOPT_0x5C
_0x4D8:
	SBIS 0x16,0
	RJMP _0x4DA
	CALL SUBOPT_0x4D
	CALL SUBOPT_0x5E
	CALL SUBOPT_0x55
	CALL SUBOPT_0x5D
	CALL SUBOPT_0x58
	RJMP _0x4D8
_0x4DA:
	LDS  R30,_ValueRS
	LDS  R31,_ValueRS+1
	SBIW R30,1
	LDI  R26,LOW(_EPR_Max_RS)
	LDI  R27,HIGH(_EPR_Max_RS)
	CALL SUBOPT_0x60
	LDI  R26,LOW(_EPR_Min_LS)
	LDI  R27,HIGH(_EPR_Min_LS)
	CALL __EEPROMWRW
	CALL _lcd_clear
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_gotoxy
	__POINTW1FN _0x0,149
	CALL SUBOPT_0x53
	CALL _lcd_clear
	LDI  R30,LOW(1)
	STS  _Accuracy_Sensor,R30
	LDI  R26,LOW(_Setting_Robot)
	LDI  R27,HIGH(_Setting_Robot)
	CALL __EEPROMRDW
	ORI  R30,1
	LDI  R26,LOW(_Setting_Robot)
	LDI  R27,HIGH(_Setting_Robot)
	CALL __EEPROMWRW
	RCALL _Disable_Sensor
	RET

	.DSEG
_0x4CE:
	.BYTE 0x15
;
;
;void main(void)
; 0000 0026 {

	.CSEG
_main:
; 0000 0027 
; 0000 0028         Index_Robot.X =0;
	LDI  R30,LOW(0)
	STS  _Index_Robot,R30
; 0000 0029         Index_Robot.Y =0;
	__PUTB1MN _Index_Robot,1
; 0000 002A 
; 0000 002B         Finish_Home_1.X =7;
	CALL SUBOPT_0x43
; 0000 002C         Finish_Home_1.Y =7;
; 0000 002D         Finish_Home_2.X =8;
	CALL SUBOPT_0x44
; 0000 002E         Finish_Home_2.Y =7;
; 0000 002F         Finish_Home_3.X =7;
	CALL SUBOPT_0x45
; 0000 0030         Finish_Home_3.Y =8;
; 0000 0031         Finish_Home_4.X =8;
	CALL SUBOPT_0x46
; 0000 0032         Finish_Home_4.Y =8;
; 0000 0033 
; 0000 0034     Code_Main();
	CALL _Code_Main
; 0000 0035     lcd_init(20);
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _lcd_init
; 0000 0036     //PORTD=0x01;
; 0000 0037     MSRM = 4 ; MSLM = 4 ;
	LDI  R30,LOW(4)
	MOV  R5,R30
	MOV  R4,R30
; 0000 0038     #asm("sei")
	sei
; 0000 0039     lcd_gotoxy(0,0);lcd_putsf("==     Jerry      ==");
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	CALL _lcd_gotoxy
	__POINTW1FN _0x0,199
	CALL SUBOPT_0x5C
; 0000 003A     sprintf(buff,"==  Version %d %d  ==",VersionJerry,VersionProgram);lcd_gotoxy(0,1);lcd_puts(buff);
	CALL SUBOPT_0x4D
	__POINTW1FN _0x0,220
	CALL SUBOPT_0x4E
	LDI  R30,LOW(1)
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x50
; 0000 003B     lcd_gotoxy(0,2);lcd_putsf("   Elmira Mousavi   ");
	__POINTW1FN _0x0,242
	CALL SUBOPT_0x5C
; 0000 003C     lcd_gotoxy(0,3);lcd_putsf("    Hoda RazmAra    ");
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _lcd_gotoxy
	__POINTW1FN _0x0,263
	CALL SUBOPT_0x53
; 0000 003D     delay_ms(1000);
; 0000 003E /*
; 0000 003F     Wheel_Right_Motor = Front_Motor ;
; 0000 0040     Wheel_Left_Motor = Front_Motor ;
; 0000 0041     Speed_Right_Motor = 100 ;
; 0000 0042     Speed_Left_Motor = 100 ;
; 0000 0043     Acceleration_Motor  = 5 ;
; 0000 0044 
; 0000 0045     delay_ms(2000);
; 0000 0046 
; 0000 0047     Wheel_Right_Motor = Front_Motor ;
; 0000 0048     Wheel_Left_Motor = Front_Motor ;
; 0000 0049     Speed_Right_Motor = 10 ;
; 0000 004A     Speed_Left_Motor = 10 ;
; 0000 004B     Acceleration_Motor  = 1 ;
; 0000 004C */
; 0000 004D     // Test Button -------------------------------
; 0000 004E     /*
; 0000 004F     while (1)
; 0000 0050     {
; 0000 0051         sprintf(buff,"PINB %d_",(PINB & 0x08 ));
; 0000 0052         lcd_gotoxy(0,1);
; 0000 0053         lcd_puts(buff);
; 0000 0054         delay_ms(100);
; 0000 0055     }
; 0000 0056 
; 0000 0057     //--------------------------------------------
; 0000 0058     */
; 0000 0059     if (( PORT_Button1 & PIN_Button1 ) == 0x00 )
	SBIS 0x16,0
; 0000 005A         {
; 0000 005B             Setup_Jerr_7();
	RCALL _Setup_Jerr_7
; 0000 005C         }
; 0000 005D     Load_Config();
	RCALL _Load_Config
; 0000 005E 
; 0000 005F     //while( ValueFRS < 500 );        // Wait For Button Start
; 0000 0060     lcd_clear();
	CALL _lcd_clear
; 0000 0061     lcd_gotoxy(7,1);lcd_putsf("Start");delay_ms(1000);
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_gotoxy
	__POINTW1FN _0x0,284
	CALL SUBOPT_0x53
; 0000 0062     lcd_clear();
	CALL _lcd_clear
; 0000 0063 
; 0000 0064 
; 0000 0065     Enable_Motor();
	RCALL _Enable_Motor
; 0000 0066     Enable_Sensor();
	RCALL _Enable_Sensor
; 0000 0067         //Disable_Motor();
; 0000 0068                 //PORTD.4 = 0 ;
; 0000 0069                 //PORTD.0 = 1 ;
; 0000 006A                 //PORTD.5 = 0 ;
; 0000 006B                 //PORTD.7 = 1 ;
; 0000 006C                 //PORTD.6 = 1 ;
; 0000 006D                 //PORTD.1 = 1 ;
; 0000 006E                 //while(1);
; 0000 006F     MSRM = 5 ;
	LDI  R30,LOW(5)
	MOV  R5,R30
; 0000 0070     MSLM = 5 ;
	MOV  R4,R30
; 0000 0071 
; 0000 0072     //Wheel_Right_Motor = Front_Motor ;
; 0000 0073     //Wheel_Left_Motor = Front_Motor ;
; 0000 0074     //Speed_Right_Motor = MSRM ;
; 0000 0075     //Speed_Left_Motor  = MSLM ;
; 0000 0076 
; 0000 0077     //Front();//Front();Front();Front();Front();Front();Front();Front();
; 0000 0078     //Front();Front();Front();Front();Front();Front();Front();Front();
; 0000 0079     //Right();
; 0000 007A     //while (( PORT_Button1 & PIN_Button1 ) != 0x00 );
; 0000 007B     //delay_ms(1000);
; 0000 007C     //Front();
; 0000 007D 
; 0000 007E 
; 0000 007F     Encoder_Right = 0 ;
	CALL SUBOPT_0x48
; 0000 0080         Encoder_Left = 0 ;
; 0000 0081 
; 0000 0082     while (1)
_0x4DC:
; 0000 0083         {
; 0000 0084          Go_Speed();
	RCALL _Go_Speed
; 0000 0085 
; 0000 0086 
; 0000 0087          //delay_ms(1000);
; 0000 0088          //if ( Small_Len_Way == On_ALG )
; 0000 0089          //       {
; 0000 008A          //           Change_Angle_Robot_For_Max_Speed_Robot();
; 0000 008B          //           Small_Len_Way = Off_ALG;
; 0000 008C          //            while ( Homes[Index_Robot.X][Index_Robot.Y] != 0 ) Go_Control_Speed();
; 0000 008D          //       }
; 0000 008E 
; 0000 008F 
; 0000 0090          //if (Encoder_Right > 50)PORTC.6=1;
; 0000 0091          //if (Encoder_Left > 50)PORTC.5=1;
; 0000 0092         //Right();
; 0000 0093         //Disable_Sensor();
; 0000 0094         //delay_ms(1000);
; 0000 0095 
; 0000 0096         //Go();
; 0000 0097         //delay_ms(1000);
; 0000 0098         /*
; 0000 0099         lcd_gotoxy(0,0);lcd_putsf("                    ");
; 0000 009A             lcd_gotoxy(0,1);lcd_putsf("                    ");
; 0000 009B             lcd_gotoxy(0,2);lcd_putsf("                    ");
; 0000 009C             lcd_gotoxy(0,3);lcd_putsf("                    ");
; 0000 009D 
; 0000 009E 
; 0000 009F             sprintf(buff,"En R %d L %d ",Encoder_Right,Encoder_Left);
; 0000 00A0             lcd_gotoxy(0,0);lcd_puts(buff);
; 0000 00A1 
; 0000 00A2             sprintf(buff,"FCS %d C %d M %d ",ValueFCS,Center_FCS,Max_FCS);
; 0000 00A3             lcd_gotoxy(0,1);lcd_puts(buff);
; 0000 00A4 
; 0000 00A5             sprintf(buff,"FRS %d ",ValueFRS);
; 0000 00A6             lcd_gotoxy(0,2);lcd_puts(buff);
; 0000 00A7 
; 0000 00A8             sprintf(buff,"FLS %d ",ValueFLS);
; 0000 00A9             lcd_gotoxy(10,2);lcd_puts(buff);
; 0000 00AA 
; 0000 00AB 
; 0000 00AC 
; 0000 00AD             sprintf(buff,"RS %d ",ValueRS);
; 0000 00AE             lcd_gotoxy(0,3);lcd_puts(buff);
; 0000 00AF 
; 0000 00B0             sprintf(buff,"LS %d ",ValueLS,);
; 0000 00B1             lcd_gotoxy(10,3);lcd_puts(buff);
; 0000 00B2 
; 0000 00B3             delay_ms(50);
; 0000 00B4        */
; 0000 00B5             //PORTC=0xc1;delay_ms(2);
; 0000 00B6             //FCS_On = read_adc(4);
; 0000 00B7             //PORTC=0x00;delay_ms(2);
; 0000 00B8             //FCS_Off = read_adc(4);
; 0000 00B9             //ValueFCS = FCS_Off - FCS_On ;
; 0000 00BA         //PORTC=0x80;
; 0000 00BB         //delay_ms(1);
; 0000 00BC 
; 0000 00BD         //sprintf(buff,"%d_%d_",ValueRS,ValueFRS);
; 0000 00BE         //lcd_gotoxy(0,0);
; 0000 00BF         //lcd_puts(buff);
; 0000 00C0 
; 0000 00C1         //Speed_Right_Motor= (ValueRS/100);
; 0000 00C2         //Speed_Left_Motor= (ValueLS/100);
; 0000 00C3         //PORTC=0x00;
; 0000 00C4         //delay_ms(1);
; 0000 00C5 
; 0000 00C6         //sprintf(buff,"%d_%d_",ValueLS,ValueFLS);
; 0000 00C7         //lcd_gotoxy(0,1);
; 0000 00C8         //lcd_puts(buff);
; 0000 00C9         //delay_ms(50);
; 0000 00CA 
; 0000 00CB         //lcd_gotoxy(0,1);
; 0000 00CC         //lcd_putsf("Front ");
; 0000 00CD                             //Front();
; 0000 00CE             //Right();
; 0000 00CF         //lcd_gotoxy(0,1);
; 0000 00D0         //lcd_putsf("Stop  ");
; 0000 00D1             //delay_ms(5000);
; 0000 00D2 
; 0000 00D3         // Place your code here
; 0000 00D4         /*
; 0000 00D5         lcd_clear();
; 0000 00D6         sprintf(buff,"R: %d ",Center_FRS);lcd_gotoxy(0,0);lcd_puts(buff);
; 0000 00D7         sprintf(buff,"L: %d ",Center_FLS);lcd_gotoxy(0,1);lcd_puts(buff);
; 0000 00D8 
; 0000 00D9         if (( Setting_Robot & Run_Setup ) == Run_Setup )
; 0000 00DA         {
; 0000 00DB             lcd_gotoxy(0,2);lcd_putsf("1");
; 0000 00DC         }
; 0000 00DD         else
; 0000 00DE         {
; 0000 00DF             lcd_gotoxy(0,2);lcd_putsf("0");
; 0000 00E0         }
; 0000 00E1         sprintf(buff,"Setting: %d ",Setting_Robot);lcd_gotoxy(0,3);lcd_puts(buff);
; 0000 00E2         delay_ms(50);
; 0000 00E3         */
; 0000 00E4       }
	RJMP _0x4DC
; 0000 00E5       /*
; 0000 00E6       Go();
; 0000 00E7       Go_Speed_RPT_NO_Update_Ver2();
; 0000 00E8       Go_Update3();
; 0000 00E9       Go_45_Ver3();
; 0000 00EA       Go_RPT();
; 0000 00EB       Go_Arc();
; 0000 00EC       Go_Speed();
; 0000 00ED       Go_Speed_RPT();
; 0000 00EE       Go_Speed_Ver2();
; 0000 00EF       Go_45();
; 0000 00F0       Go_45_Ver2();
; 0000 00F1       Go_Speed_RPT_NO_Update();
; 0000 00F2       */
; 0000 00F3 }
_0x4DF:
	RJMP _0x4DF
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_put_buff_G100:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2000010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,4
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2000012
	__CPWRN 16,17,2
	BRLO _0x2000013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2000012:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL SUBOPT_0x35
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	TST  R31
	BRMI _0x2000014
	CALL SUBOPT_0x35
_0x2000014:
_0x2000013:
	RJMP _0x2000015
_0x2000010:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2000015:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,5
	RET
__print_G100:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2000016:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x2000018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x200001C
	CPI  R18,37
	BRNE _0x200001D
	LDI  R17,LOW(1)
	RJMP _0x200001E
_0x200001D:
	CALL SUBOPT_0x61
_0x200001E:
	RJMP _0x200001B
_0x200001C:
	CPI  R30,LOW(0x1)
	BRNE _0x200001F
	CPI  R18,37
	BRNE _0x2000020
	CALL SUBOPT_0x61
	RJMP _0x20000C9
_0x2000020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2000021
	LDI  R16,LOW(1)
	RJMP _0x200001B
_0x2000021:
	CPI  R18,43
	BRNE _0x2000022
	LDI  R20,LOW(43)
	RJMP _0x200001B
_0x2000022:
	CPI  R18,32
	BRNE _0x2000023
	LDI  R20,LOW(32)
	RJMP _0x200001B
_0x2000023:
	RJMP _0x2000024
_0x200001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2000025
_0x2000024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2000026
	ORI  R16,LOW(128)
	RJMP _0x200001B
_0x2000026:
	RJMP _0x2000027
_0x2000025:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x200001B
_0x2000027:
	CPI  R18,48
	BRLO _0x200002A
	CPI  R18,58
	BRLO _0x200002B
_0x200002A:
	RJMP _0x2000029
_0x200002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x200001B
_0x2000029:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x200002F
	CALL SUBOPT_0x62
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	LDD  R26,Z+4
	ST   -Y,R26
	CALL SUBOPT_0x63
	RJMP _0x2000030
_0x200002F:
	CPI  R30,LOW(0x73)
	BRNE _0x2000032
	CALL SUBOPT_0x62
	CALL SUBOPT_0x64
	CALL _strlen
	MOV  R17,R30
	RJMP _0x2000033
_0x2000032:
	CPI  R30,LOW(0x70)
	BRNE _0x2000035
	CALL SUBOPT_0x62
	CALL SUBOPT_0x64
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2000033:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2000036
_0x2000035:
	CPI  R30,LOW(0x64)
	BREQ _0x2000039
	CPI  R30,LOW(0x69)
	BRNE _0x200003A
_0x2000039:
	ORI  R16,LOW(4)
	RJMP _0x200003B
_0x200003A:
	CPI  R30,LOW(0x75)
	BRNE _0x200003C
_0x200003B:
	LDI  R30,LOW(_tbl10_G100*2)
	LDI  R31,HIGH(_tbl10_G100*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x200003D
_0x200003C:
	CPI  R30,LOW(0x58)
	BRNE _0x200003F
	ORI  R16,LOW(8)
	RJMP _0x2000040
_0x200003F:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x2000071
_0x2000040:
	LDI  R30,LOW(_tbl16_G100*2)
	LDI  R31,HIGH(_tbl16_G100*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x200003D:
	SBRS R16,2
	RJMP _0x2000042
	CALL SUBOPT_0x62
	CALL SUBOPT_0x65
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2000043
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x2000043:
	CPI  R20,0
	BREQ _0x2000044
	SUBI R17,-LOW(1)
	RJMP _0x2000045
_0x2000044:
	ANDI R16,LOW(251)
_0x2000045:
	RJMP _0x2000046
_0x2000042:
	CALL SUBOPT_0x62
	CALL SUBOPT_0x65
_0x2000046:
_0x2000036:
	SBRC R16,0
	RJMP _0x2000047
_0x2000048:
	CP   R17,R21
	BRSH _0x200004A
	SBRS R16,7
	RJMP _0x200004B
	SBRS R16,2
	RJMP _0x200004C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x200004D
_0x200004C:
	LDI  R18,LOW(48)
_0x200004D:
	RJMP _0x200004E
_0x200004B:
	LDI  R18,LOW(32)
_0x200004E:
	CALL SUBOPT_0x61
	SUBI R21,LOW(1)
	RJMP _0x2000048
_0x200004A:
_0x2000047:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x200004F
_0x2000050:
	CPI  R19,0
	BREQ _0x2000052
	SBRS R16,3
	RJMP _0x2000053
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x2000054
_0x2000053:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2000054:
	CALL SUBOPT_0x61
	CPI  R21,0
	BREQ _0x2000055
	SUBI R21,LOW(1)
_0x2000055:
	SUBI R19,LOW(1)
	RJMP _0x2000050
_0x2000052:
	RJMP _0x2000056
_0x200004F:
_0x2000058:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x200005A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x200005C
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x200005A
_0x200005C:
	CPI  R18,58
	BRLO _0x200005D
	SBRS R16,3
	RJMP _0x200005E
	SUBI R18,-LOW(7)
	RJMP _0x200005F
_0x200005E:
	SUBI R18,-LOW(39)
_0x200005F:
_0x200005D:
	SBRC R16,4
	RJMP _0x2000061
	CPI  R18,49
	BRSH _0x2000063
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2000062
_0x2000063:
	RJMP _0x20000CA
_0x2000062:
	CP   R21,R19
	BRLO _0x2000067
	SBRS R16,0
	RJMP _0x2000068
_0x2000067:
	RJMP _0x2000066
_0x2000068:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2000069
	LDI  R18,LOW(48)
_0x20000CA:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x200006A
	ANDI R16,LOW(251)
	ST   -Y,R20
	CALL SUBOPT_0x63
	CPI  R21,0
	BREQ _0x200006B
	SUBI R21,LOW(1)
_0x200006B:
_0x200006A:
_0x2000069:
_0x2000061:
	CALL SUBOPT_0x61
	CPI  R21,0
	BREQ _0x200006C
	SUBI R21,LOW(1)
_0x200006C:
_0x2000066:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2000059
	RJMP _0x2000058
_0x2000059:
_0x2000056:
	SBRS R16,0
	RJMP _0x200006D
_0x200006E:
	CPI  R21,0
	BREQ _0x2000070
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL SUBOPT_0x63
	RJMP _0x200006E
_0x2000070:
_0x200006D:
_0x2000071:
_0x2000030:
_0x20000C9:
	LDI  R17,LOW(0)
_0x200001B:
	RJMP _0x2000016
_0x2000018:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CALL __GETW1P
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	CALL __SAVELOCR4
	CALL SUBOPT_0x66
	SBIW R30,0
	BRNE _0x2000072
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x2080003
_0x2000072:
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	MOVW R16,R26
	CALL SUBOPT_0x66
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G100)
	LDI  R31,HIGH(_put_buff_G100)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,10
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G100
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x2080003:
	CALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.DSEG

	.CSEG
__lcd_write_nibble_G101:
	LD   R30,Y
	ANDI R30,LOW(0x10)
	BREQ _0x2020004
	SBI  0x18,4
	RJMP _0x2020005
_0x2020004:
	CBI  0x18,4
_0x2020005:
	LD   R30,Y
	ANDI R30,LOW(0x20)
	BREQ _0x2020006
	SBI  0x18,5
	RJMP _0x2020007
_0x2020006:
	CBI  0x18,5
_0x2020007:
	LD   R30,Y
	ANDI R30,LOW(0x40)
	BREQ _0x2020008
	SBI  0x18,6
	RJMP _0x2020009
_0x2020008:
	CBI  0x18,6
_0x2020009:
	LD   R30,Y
	ANDI R30,LOW(0x80)
	BREQ _0x202000A
	SBI  0x18,7
	RJMP _0x202000B
_0x202000A:
	CBI  0x18,7
_0x202000B:
	__DELAY_USB 5
	SBI  0x18,3
	__DELAY_USB 13
	CBI  0x18,3
	__DELAY_USB 13
	RJMP _0x2080001
__lcd_write_data:
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_nibble_G101
    ld    r30,y
    swap  r30
    st    y,r30
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_nibble_G101
	__DELAY_USB 133
	RJMP _0x2080001
_lcd_gotoxy:
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G101)
	SBCI R31,HIGH(-__base_y_G101)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	RCALL __lcd_write_data
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
	ADIW R28,2
	RET
_lcd_clear:
	LDI  R30,LOW(2)
	CALL SUBOPT_0x67
	LDI  R30,LOW(12)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(1)
	CALL SUBOPT_0x67
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x2020011
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R26,R30
	BRLO _0x2020010
_0x2020011:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	ST   -Y,R30
	RCALL _lcd_gotoxy
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BRNE _0x2020013
	RJMP _0x2080001
_0x2020013:
_0x2020010:
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
	SBI  0x18,1
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_data
	CBI  0x18,1
	RJMP _0x2080001
_lcd_puts:
	ST   -Y,R17
_0x2020014:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2020016
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x2020014
_0x2020016:
	RJMP _0x2080002
_lcd_putsf:
	ST   -Y,R17
_0x2020017:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2020019
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x2020017
_0x2020019:
_0x2080002:
	LDD  R17,Y+0
	ADIW R28,3
	RET
_lcd_init:
	SBI  0x17,4
	SBI  0x17,5
	SBI  0x17,6
	SBI  0x17,7
	SBI  0x17,3
	SBI  0x17,1
	SBI  0x17,2
	CBI  0x18,3
	CBI  0x18,1
	CBI  0x18,2
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G101,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G101,3
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	CALL SUBOPT_0x68
	CALL SUBOPT_0x68
	CALL SUBOPT_0x68
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_write_nibble_G101
	__DELAY_USW 200
	LDI  R30,LOW(40)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(133)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL __lcd_write_data
	RCALL _lcd_clear
_0x2080001:
	ADIW R28,1
	RET

	.CSEG

	.CSEG
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.DSEG
_buff:
	.BYTE 0x14
_FCS_Off:
	.BYTE 0x2
_ValueFCS:
	.BYTE 0x2
_FRS_On:
	.BYTE 0x2
_FRS_Off:
	.BYTE 0x2
_ValueFRS:
	.BYTE 0x2
_FLS_On:
	.BYTE 0x2
_FLS_Off:
	.BYTE 0x2
_ValueFLS:
	.BYTE 0x2
_RS_On:
	.BYTE 0x2
_RS_Off:
	.BYTE 0x2
_ValueRS:
	.BYTE 0x2
_LS_On:
	.BYTE 0x2
_LS_Off:
	.BYTE 0x2
_ValueLS:
	.BYTE 0x2
_Accuracy_Sensor:
	.BYTE 0x1
_Counter_Accuracy_Sensor:
	.BYTE 0x1
_Speed_Right_Motor:
	.BYTE 0x1
_Wheel_Right_Motor:
	.BYTE 0x1
_PWM_Right_Motor:
	.BYTE 0x1
_Speed_Left_Motor:
	.BYTE 0x1
_Wheel_Left_Motor:
	.BYTE 0x1
_PWM_Left_Motor:
	.BYTE 0x1
_PWM_Counter:
	.BYTE 0x1
_Acceleration_Motor:
	.BYTE 0x1
_Acceleration_Counter:
	.BYTE 0x1
_Index_Robot:
	.BYTE 0x2
_Finish_Home_1:
	.BYTE 0x2
_Finish_Home_2:
	.BYTE 0x2
_Finish_Home_3:
	.BYTE 0x2
_Finish_Home_4:
	.BYTE 0x2
_Angle_Robot:
	.BYTE 0x1
_Angle_Move_Robot_First:
	.BYTE 0x1
_Angle_Move_Robot_Second:
	.BYTE 0x1
_Back_Way:
	.BYTE 0x1
_Len_Way:
	.BYTE 0x1
_Len_Way_A:
	.BYTE 0x1
_Small_Len_Way:
	.BYTE 0x1
_Check_Home_Finish:
	.BYTE 0x1
_Sens_Sensor:
	.BYTE 0x1
_Type_Move:
	.BYTE 0x1
_Model_Move:
	.BYTE 0x1
_Index_Robot_Point:
	.BYTE 0x1
_IndexA:
	.BYTE 0x1
_Switch:
	.BYTE 0x1
_And:
	.BYTE 0x1
_And_x:
	.BYTE 0x1
_Home_Update3:
	.BYTE 0xAE
_i:
	.BYTE 0x2
_j:
	.BYTE 0x2
_k:
	.BYTE 0x2
_l:
	.BYTE 0x2
_Homes:
	.BYTE 0x100
_Wall_Homes:
	.BYTE 0x100
_Center_FCS:
	.BYTE 0x2
_Max_FCS:
	.BYTE 0x2
_Center_FRS:
	.BYTE 0x2
_Max_FRS:
	.BYTE 0x2
_Center_FLS:
	.BYTE 0x2
_Max_FLS:
	.BYTE 0x2
_Center_RS:
	.BYTE 0x2
_Max_RS:
	.BYTE 0x2
_Min_RS:
	.BYTE 0x2
_Center_LS:
	.BYTE 0x2
_Max_LS:
	.BYTE 0x2
_Min_LS:
	.BYTE 0x2
_ik:
	.BYTE 0x1
_jk:
	.BYTE 0x1
_AMCFSR:
	.BYTE 0x2
_AMCFSL:
	.BYTE 0x2

	.ESEG
_Setting_Robot:
	.DW  0x0
_EPR_Center_FCS:
	.BYTE 0x2
_EPR_Max_FCS:
	.BYTE 0x2
_EPR_Center_FRS:
	.BYTE 0x2
_EPR_Max_FRS:
	.BYTE 0x2
_EPR_Center_FLS:
	.BYTE 0x2
_EPR_Max_FLS:
	.BYTE 0x2
_EPR_Center_RS:
	.BYTE 0x2
_EPR_Max_RS:
	.BYTE 0x2
_EPR_Min_RS:
	.BYTE 0x2
_EPR_Center_LS:
	.BYTE 0x2
_EPR_Max_LS:
	.BYTE 0x2
_EPR_Min_LS:
	.BYTE 0x2
_EPR_Wall_Homes:
	.DB  LOW(0x1010103),HIGH(0x1010103),BYTE3(0x1010103),BYTE4(0x1010103)
	.DB  LOW(0x1010101),HIGH(0x1010101),BYTE3(0x1010101),BYTE4(0x1010101)
	.DB  LOW(0x1010101),HIGH(0x1010101),BYTE3(0x1010101),BYTE4(0x1010101)
	.DB  LOW(0x9010101),HIGH(0x9010101),BYTE3(0x9010101),BYTE4(0x9010101)
	.DB  LOW(0x2),HIGH(0x2),BYTE3(0x2),BYTE4(0x2)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x8000000),HIGH(0x8000000),BYTE3(0x8000000),BYTE4(0x8000000)
	.DB  LOW(0x2),HIGH(0x2),BYTE3(0x2),BYTE4(0x2)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x8000000),HIGH(0x8000000),BYTE3(0x8000000),BYTE4(0x8000000)
	.DB  LOW(0x2),HIGH(0x2),BYTE3(0x2),BYTE4(0x2)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x8000000),HIGH(0x8000000),BYTE3(0x8000000),BYTE4(0x8000000)
	.DB  LOW(0x2),HIGH(0x2),BYTE3(0x2),BYTE4(0x2)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x8000000),HIGH(0x8000000),BYTE3(0x8000000),BYTE4(0x8000000)
	.DB  LOW(0x2),HIGH(0x2),BYTE3(0x2),BYTE4(0x2)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x8000000),HIGH(0x8000000),BYTE3(0x8000000),BYTE4(0x8000000)
	.DB  LOW(0x2),HIGH(0x2),BYTE3(0x2),BYTE4(0x2)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x8000000),HIGH(0x8000000),BYTE3(0x8000000),BYTE4(0x8000000)
	.DB  LOW(0x2),HIGH(0x2),BYTE3(0x2),BYTE4(0x2)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x8000000),HIGH(0x8000000),BYTE3(0x8000000),BYTE4(0x8000000)
	.DB  LOW(0x2),HIGH(0x2),BYTE3(0x2),BYTE4(0x2)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x8000000),HIGH(0x8000000),BYTE3(0x8000000),BYTE4(0x8000000)
	.DB  LOW(0x2),HIGH(0x2),BYTE3(0x2),BYTE4(0x2)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x8000000),HIGH(0x8000000),BYTE3(0x8000000),BYTE4(0x8000000)
	.DB  LOW(0x2),HIGH(0x2),BYTE3(0x2),BYTE4(0x2)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x8000000),HIGH(0x8000000),BYTE3(0x8000000),BYTE4(0x8000000)
	.DB  LOW(0x2),HIGH(0x2),BYTE3(0x2),BYTE4(0x2)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x8000000),HIGH(0x8000000),BYTE3(0x8000000),BYTE4(0x8000000)
	.DB  LOW(0x2),HIGH(0x2),BYTE3(0x2),BYTE4(0x2)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x8000000),HIGH(0x8000000),BYTE3(0x8000000),BYTE4(0x8000000)
	.DB  LOW(0x2),HIGH(0x2),BYTE3(0x2),BYTE4(0x2)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x8000000),HIGH(0x8000000),BYTE3(0x8000000),BYTE4(0x8000000)
	.DB  LOW(0x2),HIGH(0x2),BYTE3(0x2),BYTE4(0x2)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x8000000),HIGH(0x8000000),BYTE3(0x8000000),BYTE4(0x8000000)
	.DB  LOW(0x4040406),HIGH(0x4040406),BYTE3(0x4040406),BYTE4(0x4040406)
	.DB  LOW(0x4040404),HIGH(0x4040404),BYTE3(0x4040404),BYTE4(0x4040404)
	.DB  LOW(0x4040404),HIGH(0x4040404),BYTE3(0x4040404),BYTE4(0x4040404)
	.DB  LOW(0xC040404),HIGH(0xC040404),BYTE3(0xC040404),BYTE4(0xC040404)

	.DSEG
__base_y_G101:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x0:
	LDS  R30,_Accuracy_Sensor
	LDI  R31,0
	CALL __DIVW21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x1:
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R30
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _Read_Sensor
	STS  _Sens_Sensor,R30
	LDS  R26,_Sens_Sensor
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 73 TIMES, CODE SIZE REDUCTION:213 WORDS
SUBOPT_0x3:
	LDS  R30,_Index_Robot
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 35 TIMES, CODE SIZE REDUCTION:371 WORDS
SUBOPT_0x4:
	CALL __LSLW4
	SUBI R30,LOW(-_Wall_Homes)
	SBCI R31,HIGH(-_Wall_Homes)
	MOVW R26,R30
	__GETB1MN _Index_Robot,1
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5:
	ORI  R30,4
	ST   X,R30
	LDS  R26,_Index_Robot
	CPI  R26,LOW(0xF)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x6:
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _Read_Sensor
	STS  _Sens_Sensor,R30
	LDS  R26,_Sens_Sensor
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x7:
	ORI  R30,8
	ST   X,R30
	__GETB2MN _Index_Robot,1
	CPI  R26,LOW(0xF)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x8:
	CALL __LSLW4
	SUBI R30,LOW(-_Wall_Homes)
	SBCI R31,HIGH(-_Wall_Homes)
	MOVW R26,R30
	__GETB1MN _Index_Robot,1
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x9:
	ADIW R30,1
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ORI  R30,2
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0xA:
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _Read_Sensor
	STS  _Sens_Sensor,R30
	LDS  R26,_Sens_Sensor
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xB:
	ORI  R30,1
	ST   X,R30
	LDS  R26,_Index_Robot
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xC:
	ORI  R30,2
	ST   X,R30
	__GETB2MN _Index_Robot,1
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xD:
	SBIW R30,1
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ORI  R30,8
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0xE:
	CALL _Right
	JMP  _Right_45

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xF:
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _Lock
	LDI  R30,LOW(0)
	STS  _i,R30
	STS  _i+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x10:
	LDS  R26,_i
	LDS  R27,_i+1
	SBIW R26,16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x11:
	LDI  R30,LOW(0)
	STS  _j,R30
	STS  _j+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 19 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x12:
	LDS  R26,_j
	LDS  R27,_j+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x13:
	LDS  R30,_i
	LDS  R31,_i+1
	CALL __LSLW4
	SUBI R30,LOW(-_Homes)
	SBCI R31,HIGH(-_Homes)
	RCALL SUBOPT_0x12
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0x14:
	LDI  R26,LOW(_j)
	LDI  R27,HIGH(_j)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x15:
	LDI  R26,LOW(_i)
	LDI  R27,HIGH(_i)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:72 WORDS
SUBOPT_0x16:
	LDS  R30,_Finish_Home_1
	LDI  R31,0
	CALL __LSLW4
	SUBI R30,LOW(-_Homes)
	SBCI R31,HIGH(-_Homes)
	MOVW R26,R30
	__GETB1MN _Finish_Home_1,1
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
	LDS  R30,_Finish_Home_2
	LDI  R31,0
	CALL __LSLW4
	SUBI R30,LOW(-_Homes)
	SBCI R31,HIGH(-_Homes)
	MOVW R26,R30
	__GETB1MN _Finish_Home_2,1
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
	LDS  R30,_Finish_Home_3
	LDI  R31,0
	CALL __LSLW4
	SUBI R30,LOW(-_Homes)
	SBCI R31,HIGH(-_Homes)
	MOVW R26,R30
	__GETB1MN _Finish_Home_3,1
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
	LDS  R30,_Finish_Home_4
	LDI  R31,0
	CALL __LSLW4
	SUBI R30,LOW(-_Homes)
	SBCI R31,HIGH(-_Homes)
	MOVW R26,R30
	__GETB1MN _Finish_Home_4,1
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x17:
	LDS  R30,_i
	LDS  R31,_i+1
	CALL __LSLW4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x18:
	SUBI R30,LOW(-_Wall_Homes)
	SBCI R31,HIGH(-_Wall_Homes)
	RCALL SUBOPT_0x12
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x19:
	ANDI R30,LOW(0x8)
	STS  _And_x,R30
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1A:
	SUBI R30,LOW(-_Homes)
	SBCI R31,HIGH(-_Homes)
	MOVW R26,R30
	LDS  R30,_j
	LDS  R31,_j+1
	ADIW R30,1
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x1B:
	LDS  R30,_IndexA
	SUBI R30,-LOW(1)
	ST   X,R30
	LDI  R30,LOW(1)
	STS  _Switch,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1C:
	ANDI R30,LOW(0x4)
	STS  _And_x,R30
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x1D:
	LDS  R30,_i
	LDS  R31,_i+1
	ADIW R30,1
	CALL __LSLW4
	SUBI R30,LOW(-_Homes)
	SBCI R31,HIGH(-_Homes)
	RCALL SUBOPT_0x12
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1E:
	ANDI R30,LOW(0x1)
	STS  _And_x,R30
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x1F:
	LDS  R30,_i
	LDS  R31,_i+1
	SBIW R30,1
	CALL __LSLW4
	SUBI R30,LOW(-_Homes)
	SBCI R31,HIGH(-_Homes)
	RCALL SUBOPT_0x12
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x20:
	ANDI R30,LOW(0x2)
	STS  _And_x,R30
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x21:
	SUBI R30,LOW(-_Homes)
	SBCI R31,HIGH(-_Homes)
	MOVW R26,R30
	LDS  R30,_j
	LDS  R31,_j+1
	SBIW R30,1
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x22:
	LDI  R30,LOW(58)
	LDI  R31,HIGH(58)
	CALL __MODW21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:67 WORDS
SUBOPT_0x23:
	LDS  R26,_i
	LDS  R27,_i+1
	LDI  R30,LOW(3)
	CALL __MULB1W2U
	MOVW R26,R30
	__ADDW1MN _Home_Update3,1
	LD   R30,Z
	LDI  R31,0
	CALL __LSLW4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:39 WORDS
SUBOPT_0x24:
	SUBI R30,LOW(-_Wall_Homes)
	SBCI R31,HIGH(-_Wall_Homes)
	__PUTW1R 23,24
	MOVW R30,R26
	__ADDW1MN _Home_Update3,2
	LD   R30,Z
	__GETW2R 23,24
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x25:
	SUBI R30,LOW(-_Homes)
	SBCI R31,HIGH(-_Homes)
	__PUTW1R 23,24
	MOVW R30,R26
	__ADDW1MN _Home_Update3,2
	LD   R30,Z
	LDI  R31,0
	ADIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x26:
	__GETW2R 23,24
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	CPI  R26,LOW(0xFF)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x27:
	RCALL SUBOPT_0x12
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:141 WORDS
SUBOPT_0x28:
	STS  _k,R30
	STS  _k+1,R31
	LDS  R26,_k
	LDS  R27,_k+1
	LDI  R30,LOW(3)
	CALL __MULB1W2U
	SUBI R30,LOW(-_Home_Update3)
	SBCI R31,HIGH(-_Home_Update3)
	__PUTW1R 23,24
	LDS  R26,_i
	LDS  R27,_i+1
	LDI  R30,LOW(3)
	CALL __MULB1W2U
	SUBI R30,LOW(-_Home_Update3)
	SBCI R31,HIGH(-_Home_Update3)
	LD   R30,Z
	SUBI R30,-LOW(1)
	__GETW2R 23,24
	ST   X,R30
	LDS  R26,_k
	LDS  R27,_k+1
	LDI  R30,LOW(3)
	CALL __MULB1W2U
	__ADDW1MN _Home_Update3,1
	__PUTW1R 23,24
	LDS  R26,_i
	LDS  R27,_i+1
	LDI  R30,LOW(3)
	CALL __MULB1W2U
	__ADDW1MN _Home_Update3,1
	LD   R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:63 WORDS
SUBOPT_0x29:
	__GETW2R 23,24
	ST   X,R30
	LDS  R26,_k
	LDS  R27,_k+1
	LDI  R30,LOW(3)
	CALL __MULB1W2U
	__ADDW1MN _Home_Update3,2
	__PUTW1R 23,24
	LDS  R26,_i
	LDS  R27,_i+1
	LDI  R30,LOW(3)
	CALL __MULB1W2U
	__ADDW1MN _Home_Update3,2
	LD   R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2A:
	SUBI R30,-LOW(1)
	__GETW2R 23,24
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x2B:
	LDS  R26,_i
	LDS  R27,_i+1
	LDI  R30,LOW(3)
	CALL __MULB1W2U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x2C:
	MOVW R0,R30
	MOVW R26,R30
	__ADDW1MN _Home_Update3,1
	LD   R30,Z
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x2D:
	__ADDWRR 23,24,30,31
	MOVW R30,R0
	SUBI R30,LOW(-_Home_Update3)
	SBCI R31,HIGH(-_Home_Update3)
	LD   R30,Z
	RJMP SUBOPT_0x2A

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2E:
	MOVW R26,R30
	__ADDW1MN _Home_Update3,1
	LD   R30,Z
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2F:
	ADIW R30,1
	CALL __LSLW4
	SUBI R30,LOW(-_Homes)
	SBCI R31,HIGH(-_Homes)
	__PUTW1R 23,24
	MOVW R30,R26
	__ADDW1MN _Home_Update3,2
	LD   R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x30:
	__GETW2R 23,24
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	CPI  R26,LOW(0xFF)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x31:
	__GETW2R 23,24
	ST   X,R30
	RJMP SUBOPT_0x2B

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x32:
	SUBI R30,LOW(-_Homes)
	SBCI R31,HIGH(-_Homes)
	__PUTW1R 23,24
	MOVW R30,R26
	__ADDW1MN _Home_Update3,2
	LD   R30,Z
	LDI  R31,0
	SBIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x33:
	LDI  R31,0
	SBIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x34:
	SBIW R30,1
	CALL __LSLW4
	SUBI R30,LOW(-_Homes)
	SBCI R31,HIGH(-_Homes)
	__PUTW1R 23,24
	MOVW R30,R26
	__ADDW1MN _Home_Update3,2
	LD   R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x35:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x36:
	LDI  R30,LOW(8)
	STS  _And,R30
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:87 WORDS
SUBOPT_0x37:
	LDS  R26,_And
	AND  R30,R26
	STS  _And,R30
	LDS  R26,_And
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 28 TIMES, CODE SIZE REDUCTION:213 WORDS
SUBOPT_0x38:
	CALL __LSLW4
	SUBI R30,LOW(-_Homes)
	SBCI R31,HIGH(-_Homes)
	MOVW R26,R30
	__GETB1MN _Index_Robot,1
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:42 WORDS
SUBOPT_0x39:
	ADD  R26,R30
	ADC  R27,R31
	LD   R0,X
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3A:
	ADIW R30,1
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CP   R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x3B:
	__GETB1MN _Index_Robot,1
	SUBI R30,-LOW(1)
	__PUTB1MN _Index_Robot,1
	LDI  R30,LOW(8)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3C:
	LDI  R30,LOW(4)
	STS  _And,R30
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x3D:
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CP   R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x3E:
	LDS  R30,_Index_Robot
	SUBI R30,-LOW(1)
	STS  _Index_Robot,R30
	LDI  R30,LOW(4)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3F:
	LDI  R30,LOW(1)
	STS  _And,R30
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x40:
	LDI  R30,LOW(2)
	STS  _And,R30
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x41:
	CALL __LSLW4
	SUBI R30,LOW(-_Homes)
	SBCI R31,HIGH(-_Homes)
	MOVW R26,R30
	__GETB1MN _Index_Robot,1
	RJMP SUBOPT_0x33

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x42:
	__GETB1MN _Index_Robot,1
	RJMP SUBOPT_0x33

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x43:
	LDI  R30,LOW(7)
	STS  _Finish_Home_1,R30
	__PUTB1MN _Finish_Home_1,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x44:
	LDI  R30,LOW(8)
	STS  _Finish_Home_2,R30
	LDI  R30,LOW(7)
	__PUTB1MN _Finish_Home_2,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x45:
	LDI  R30,LOW(7)
	STS  _Finish_Home_3,R30
	LDI  R30,LOW(8)
	__PUTB1MN _Finish_Home_3,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x46:
	LDI  R30,LOW(8)
	STS  _Finish_Home_4,R30
	__PUTB1MN _Finish_Home_4,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x47:
	LDS  R26,_ValueFCS
	LDS  R27,_ValueFCS+1
	CP   R26,R30
	CPC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x48:
	CLR  R8
	CLR  R9
	CLR  R10
	CLR  R11
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x49:
	LDS  R26,_ValueRS
	LDS  R27,_ValueRS+1
	CP   R30,R26
	CPC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4A:
	LDS  R26,_ValueLS
	LDS  R27,_ValueLS+1
	CP   R30,R26
	CPC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4B:
	STS  _Speed_Right_Motor,R5
	STS  _Speed_Left_Motor,R4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4C:
	STS  _Wheel_Right_Motor,R30
	LDI  R30,LOW(4)
	STS  _Wheel_Left_Motor,R30
	RJMP SUBOPT_0x4B

;OPTIMIZER ADDED SUBROUTINE, CALLED 28 TIMES, CODE SIZE REDUCTION:51 WORDS
SUBOPT_0x4D:
	LDI  R30,LOW(_buff)
	LDI  R31,HIGH(_buff)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x4E:
	ST   -Y,R31
	ST   -Y,R30
	__GETD1N 0x7
	CALL __PUTPARD1
	__GETD1N 0x37
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:36 WORDS
SUBOPT_0x4F:
	ST   -Y,R30
	CALL _lcd_gotoxy
	RJMP SUBOPT_0x4D

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x50:
	CALL _lcd_puts
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x51:
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x52:
	CALL _lcd_clear
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x53:
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
	RJMP SUBOPT_0x51

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x54:
	__POINTW1FN _0x0,191
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_ValueFCS
	LDS  R31,_ValueFCS+1
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(1)
	RJMP SUBOPT_0x4F

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x55:
	CALL _lcd_puts
	RJMP SUBOPT_0x4D

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x56:
	__POINTW1FN _0x0,63
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_ValueFRS
	LDS  R31,_ValueFRS+1
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(2)
	RJMP SUBOPT_0x4F

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x57:
	__POINTW1FN _0x0,71
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_ValueFLS
	LDS  R31,_ValueFLS+1
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(2)
	RJMP SUBOPT_0x4F

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x58:
	CALL _lcd_puts
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x59:
	CALL __EEPROMWRW
	LDS  R30,_ValueFRS
	LDS  R31,_ValueFRS+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5A:
	CALL __EEPROMWRW
	LDS  R30,_ValueFLS
	LDS  R31,_ValueFLS+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x5B:
	CALL __EEPROMWRW
	LDI  R30,LOW(13)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_gotoxy
	__POINTW1FN _0x0,79
	RJMP SUBOPT_0x53

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x5C:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:35 WORDS
SUBOPT_0x5D:
	__POINTW1FN _0x0,64
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_ValueRS
	LDS  R31,_ValueRS+1
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(3)
	RJMP SUBOPT_0x4F

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:35 WORDS
SUBOPT_0x5E:
	__POINTW1FN _0x0,72
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_ValueLS
	LDS  R31,_ValueLS+1
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(3)
	RJMP SUBOPT_0x4F

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5F:
	CALL __EEPROMWRW
	LDS  R30,_ValueRS
	LDS  R31,_ValueRS+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x60:
	CALL __EEPROMWRW
	LDS  R30,_ValueLS
	LDS  R31,_ValueLS+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x61:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x62:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x63:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x64:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x65:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x66:
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x67:
	ST   -Y,R30
	CALL __lcd_write_data
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x68:
	LDI  R30,LOW(48)
	ST   -Y,R30
	CALL __lcd_write_nibble_G101
	__DELAY_USW 200
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__LSLW4:
	LSL  R30
	ROL  R31
__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__MULB1W2U:
	MOV  R22,R30
	MUL  R22,R26
	MOVW R30,R0
	MUL  R22,R27
	ADD  R31,R0
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
